$(function()
{
	var dicttraducciones = {};
	Init_translate();
	make_header("evidence");
	$("#evcameras").text(DevExpress.localization.formatMessage("Evidence cameras"));
	$("#camdet").text(DevExpress.localization.formatMessage("Details"));
	var evcammaxresinfo = DevExpress.localization.formatMessage("The maximum resolution for the provided JPEG stream must be between 1 and 2 megapixels");
	set_rcpopup();
	var d2;
	var evcameras;
	var listypesabierto = true;
	var detailsabierto = true;
	var showaddrow = true;
	String.prototype.replaceAll = function(search, replacement)
	{
		var target = this;
		return target.replace(new RegExp(search, 'g'), replacement);
	};

	var loadPanel = $(".loadpanel").dxLoadPanel(
	{
		shadingColor: "rgba(0,0,0,0.4)",
		visible: false,
		showIndicator: true,
		showPane: true,
		shading: true,
		width: 300,        
		onShown: function() {

			if(DEFINE_INTERFACE=="HANWHA")
				setTimeout(checkStatus, 40000);
			else
				setTimeout(checkStatus, 5000);

            setTimeout(function() {
				  loadPanel.hide();
				}, popupTime);
        },
		message: DevExpress.localization.formatMessage("Service restarting..."),
		closeOnOutsideClick: false
	}).dxLoadPanel("instance");

	var tries = 0;
	function checkStatus(){
		var d = new Date();

		if(DEFINE_INTERFACE == "HANWHA"){
			var msg1 = "";
			msg1 += "<GetSDK_APP_DATA>";
			msg1 += "<AppName>NeuralEdge</AppName>";	
			msg1 += "<Data>computerid=" + computerid + "|oper=status|adinfo=notvalue</Data>";	
			msg1 += "</GetSDK_APP_DATA>";

			$(this).sendCommandToServer({
				appname : appName,      
	  			async : false,      
				requestMessage:msg1,
				success : function(response) {
					var data = response.Data; 
		        	if(data!=undefined){
		        		try{
	        				data = JSON.parse(data);
		        		}catch(e){
		        			console("Invalid json");
		        			if(tries < 6){
								setTimeout(checkStatus, 5000);
								tries++;
							}else{
								tries = 0;
							}
		        			return;
		        		}
		        		console.log("Response Status: " + JSON.stringify(data));
		        		if(Array.isArray(data)){
		        			console.log("Data is array");
							for(var i = 0; i < data.length; i++){
								if(data[i].ident == "service"){
									if(data[i].value < 4 && data[i].value >= 0){
										loadPanel.hide();
										tries = 0;
									}else{
										if(tries < 6){
											setTimeout(checkStatus, 5000);
											tries++;
										}else{
											tries = 0;
										}
									}
								}
							}
		        		}else{
							if(tries < 6){
								setTimeout(checkStatus, 5000);
								tries++;
							}else{
								tries = 0;
							}
		        		}

					}else{
							if(tries < 6){
								setTimeout(checkStatus, 5000);
								tries++;
							}else{
								tries = 0;
							}
					}
	  			}
	  		});	
		}else{

			$.ajax(
			{
				dataType: "json",
				url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=status&d=" + getStringNormalDate(d) + localStorage.getItem("TOKEN"),
				async: false,
				success: function(data)
				{
					for(var i = 0; i < data.length; i++){
						if(data[i].ident == "service"){
							if(data[i].value < 4 && data[i].value >= 0){
								loadPanel.hide();
								tries = 0;
							}else{
								if(tries < 6){
									setTimeout(checkStatus, 5000);
									tries++;
								}else{
									tries = 0;
								}
							}
						}
					}
				}
			});
		}
	}

	$("#icon-done_info").dxButton(
	{
		type: "success",
		text: DevExpress.localization.formatMessage("Restart service"),
		onClick: function()
		{
			loadPanel.show();
			//lp = loadPanel;
			restartapp();
		}
	});

	function getimeCamera()
	{
		var dataCamara;
		$.ajax(
		{
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=gettime&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{
				CheckTokenValidity(data);
				dataCamara = new Date(data);
			}
		});
		return dataCamara;
	}
	//GET TIME
	if(DEFINE_INTERFACE == "HANWHA"){

	}else{
		$.ajax(
		{
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=gettime&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{
				CheckTokenValidity(data);
				d2 = new Date(data);
			}
		});
		$.ajax(
		{
			dataType: "json",
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlcamera&camp0=id&comp0=notequal&value0=1&maxvalues=10&dd=" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{
				CheckTokenValidity(data);
				evcameras = data;
				if (evcameras.length > 0)
				{
					showaddrow = false
				}
			}
		});
	}
	$("#evcameras").click(function()
	{
		if (listypesabierto)
		{
			$(this).removeClass('abierto');
			$(this).addClass('cerrado');
			$("#gridContainer").hide();
			listypesabierto = false;
		}
		else
		{
			$(this).addClass('abierto');
			$(this).removeClass('cerrado');
			$("#gridContainer").show();
			listypesabierto = true;
		}
	});
	$("#camdet").click(function()
	{
		if (detailsabierto)
		{
			$(this).removeClass('abierto');
			$(this).addClass('cerrado');
			$("#fiedl1").hide();
			detailsabierto = false;
		}
		else
		{
			$(this).addClass('abierto');
			$(this).removeClass('cerrado');
			$("#fiedl1").show();
			detailsabierto = true;
		}
	});
	var vlists = $("#gridContainer").dxDataGrid(
	{
		dataSource: evcameras,
		showBorders: true,
		showRowLines: true,
		keyExpr: "id",
		hoverStateEnabled: true,
		paging:
		{
			pageSize: 10
		},
		searchPanel:
		{
			visible: true,
			width: 240,
			placeholder: DevExpress.localization.formatMessage("Search...")
		},
		columns: [
		{
			dataField: "id",
			caption: DevExpress.localization.formatMessage("ID"),
			width: 50,
			allowEditing: false
		},
		{
			dataField: "description",
			caption: DevExpress.localization.formatMessage("Name"),
			validationRules: [
			{
				type: "required"
			}]
		}],
		editing:
		{
			mode: "row",
			allowUpdating: true,
			allowDeleting: true,
			texts:
			{
				confirmDeleteMessage: DevExpress.localization.formatMessage("Are you sure to delete the camera?")
			},
			allowAdding: true
		},
		selection:
		{
			mode: "single"
		},
		onToolbarPreparing: function(e)
		{
			let toolbarItems = e.toolbarOptions.items;
			toolbarItems.forEach(function(item)
			{
				if (item.name === "addRowButton")
				{
					item.visible = showaddrow
				}
			});
		},
		onSelectionChanged: function(selectedItems)
		{
			var data = selectedItems.selectedRowsData[0];
			if (data)
			{
				$("#plateslistdiv").show();
				loaddetailsEVCam(data.id)
			}
		},
		onRowUpdating: function(e)
		{
			var descritpion;
			if (typeof e.newData.description !== 'undefined')
			{
				description = e.newData.description.replaceAll('"', '').replaceAll('\'', '');
			}
			else
			{
				description = e.oldData.description.replaceAll('"', '').replaceAll('\'', '');
			}
			var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlcamera&camp0=id&value0=" + e.oldData.id + "&camp1=description&value1=" + description + "&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"));
		},
		onRowInserting: function(e)
		{
			var jqxhr = $.ajax(
			{
				url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=insertevidence&name=" + e.data.description.replaceAll('"', '').replaceAll('\'', '') + "&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
				success: function(data)
				{
					CheckTokenValidity(data);
					DevExpress.ui.notify(DevExpress.localization.formatMessage(data), "info", 1000);
					loadevcam();
				}
			});
		},
		onRowRemoving: function(e)
		{
			var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=delete&table=nlconfcamera&camp0=cameraid&comp0=equal&value0=" + e.key + localStorage.getItem("TOKEN"));
			var jqxhr2 = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=delete&table=nlcamera&camp0=id&comp0=equal&value0=" + e.key + localStorage.getItem("TOKEN"));
			$("#plateslistdiv").hide();
			e.element.find(".dx-datagrid-addrow-button").show();
			showaddrow = true;
			var repaint = $("#gridContainer").dxDataGrid("repaint");
		},
		onRowInserted: function(e)
		{
			e.element.find(".dx-datagrid-addrow-button").hide();
		}
	}).dxDataGrid("instance");

	function loadevcam()
	{
		var d = new Date();
		//elementos listas
		$.ajax(
		{
			dataType: "json",
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlcamera&camp0=id&comp0=notequal&value0=1&maxvalues=10&dd=" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			success: function(data)
			{
				CheckTokenValidity(data);
				vlists.option("dataSource", data);
			}
		});
	}

	function loaddetailsEVCam(idcam)
	{
		$("#fiedl1").empty();
		$.getJSON(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlconfcamera&camp0=cameraid&comp0=equal&value0=" + idcam + "&maxvalues=250&d=" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN")).done(function(data)
		{
			$.each(data, function(i, item)
			{
				if (item.visible == 1)
				{
					if (item.typepar == "int")
					{
						$("#fiedl1").append(" <div class='dx-field'><div class='dx-field-label'>" + DevExpress.localization.formatMessage(item.text) + "</div><div class='dx-field-value'><div id='elem" + i + "' style='float:none;display: inline-block;' ></div></div></div>");
						var valopt = (item.options).split(";");
						$("#elem" + i).dxNumberBox(
						{
							value: item.value,
							min: valopt[0],
							max: valopt[1],
							showSpinButtons: true,
							onValueChanged: function(e)
							{
								var previousValue = e.previousValue;
								var newValue = e.value;
								// Event handling commands go here
								var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=" + item.id + "&camp1=value&value1=" + newValue + "&camp2=computerid&value2=" + item.computerid + "&camp3=cameraid&value3=" + item.cameraid + "&d=" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"))
									.done(function()
									{
										DevExpress.ui.notify("Data saved", "success", 600);
									})
									.fail(function()
									{
										DevExpress.ui.notify("Data saving error", "error", 600);
									});
							}
						});
					}
					if (item.typepar == "option")
					{
						var valopt = (item.options).split(";");
						var indicef = 0;
						/*valopt.forEach(function(element) {
						    dicttraducciones[DevExpress.localization.formatMessage(element)]=element;
						    valopt[indicef]= DevExpress.localization.formatMessage(element);
						    indicef++;
					    });*/
						$("#fiedl1").append(" <div class='dx-field'><div class='dx-field-label'>" + DevExpress.localization.formatMessage(item.text) + "</div><div class='dx-field-value'><div id='elem" + i + "' style='float:none;display: inline-block;'></div> </div></div>");
						var isTrueSet = (item.value == 'true');
						$("#elem" + i).dxRadioGroup(
						{
							items: valopt,
							value: item.value,
							layout: "horizontal",
							onValueChanged: function(e)
							{
								var previousValue = e.previousValue;
								//var newValue =   dicttraducciones[e.value];
								var newValue = e.value;
								// Event handling commands go here
								var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=" + item.id + "&camp1=value&value1=" + newValue + "&camp2=computerid&value2=" + item.computerid + "&camp3=cameraid&value3=" + item.cameraid + "&d=" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"))
									.done(function()
									{
										DevExpress.ui.notify("Data saved", "success", 600);
									})
									.fail(function()
									{
										DevExpress.ui.notify("Data saving error", "error", 600);
									});
							}
						});
					}
					if (item.typepar == "string")
					{
						$("#fiedl1").append(" <div class='dx-field'><div class='dx-field-label'>" + DevExpress.localization.formatMessage(item.text) + "</div><div class='dx-field-value'><div id='elem" + i + "' style='float:none'></div></div></div>");
						var passmode = "Text";
						if (item.name == "password") passmode = "password";
						$("#elem" + i).dxTextBox(
						{
							value: item.value,
							mode: passmode,
							onValueChanged: function(e)
							{
								var previousValue = e.previousValue;
								var newValue = e.value;
								newValue = newValue.replace(/\\/g, '/');
								// Event handling commands go here
								var jqxhr = $.ajax(pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=update&table=nlconfcamera&camp0=id&value0=" + item.id + "&camp1=value&value1=" + encodeURIComponent(newValue) + "&camp2=computerid&value2=" + item.computerid + "&camp3=cameraid&value3=" + item.cameraid + "&d=" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"))
									.done(function()
									{
										DevExpress.ui.notify("Data saved", "success", 600);
									})
									.fail(function()
									{
										DevExpress.ui.notify("Data saving error", "error", 600);
									});
							}
						});
					}
				}
			});
		});
		$("#detailinfo").empty();
		$("#detailinfo").append(" <div class='dx-field'><div class='dx-field-label'></div><div class='dx-field-value'><div id='evcammess' style='float:none;display: inline-block;' >" + evcammaxresinfo + "</div></div></div>");
	}
});