///////////////
// LOGS PAGE //
///////////////

$(function()
{
	Init_translate();
	make_header("logs");
	$("#labellogtype").text(DevExpress.localization.formatMessage("Show log type:"));
	$("#labelautorefresh").text(DevExpress.localization.formatMessage("Autorefresh") + ":");
	set_rcpopup();
	var logrefresh = 1000;
	var ident;

	if(DEFINE_INTERFACE == "HANWHA"){
		var msg1 = "";
		msg1 += "<GetSDK_APP_DATA>";
		msg1 += "<AppName>NeuralEdge</AppName>";	
		msg1 += "<Data>computerid=" + computerid + "|oper=getident|adinfo=notvalue</Data>";	
		msg1 += "</GetSDK_APP_DATA>";

		$(this).sendCommandToServer({
			appname : appName,      
  			async : false,      
			requestMessage:msg1,
			success : function(response) {
				var resData = response.Data; 
	        	if(resData!=undefined){

  					console.log("Datos consulta: " + msg1);
					console.log("Respuesta : " + JSON.stringify(resData));
					console.log("Respuesta status: " + resData);
					if(resData!=undefined){
						CheckTokenValidity(resData);
						ident = resData;
					}
				}else{
				}
  			}
  		});	
	}else{
		$.ajax(
		{
			dataType: "json",
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getident" + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{
				CheckTokenValidity(data);
				ident = data;
			}
		});
	}
	
	var loadPanel = $(".loadpanel").dxLoadPanel(
	{
		shadingColor: "rgba(0,0,0,0.4)",
		visible: false,
		showIndicator: true,
		showPane: true,
		shading: true,
		width: 300,        
		onShown: function() {

			if(DEFINE_INTERFACE=="HANWHA")
				setTimeout(checkStatus, 40000);
			else
				setTimeout(checkStatus, 5000);
	
            setTimeout(function(){
				  loadPanel.hide();
				}, popupTime);
        },
		message: DevExpress.localization.formatMessage("Service restarting..."),
		closeOnOutsideClick: false
	}).dxLoadPanel("instance");

	var tries = 0;
	function checkStatus(){
		var d = new Date();

		if(DEFINE_INTERFACE == "HANWHA"){
			var msg1 = "";
			msg1 += "<GetSDK_APP_DATA>";
			msg1 += "<AppName>NeuralEdge</AppName>";	
			msg1 += "<Data>computerid=" + computerid + "|oper=status|adinfo=notvalue</Data>";	
			msg1 += "</GetSDK_APP_DATA>";

			$(this).sendCommandToServer({
				appname : appName,      
	  			async : false,      
				requestMessage:msg1,
				success : function(response) {
					var data = response.Data; 
		        	if(data!=undefined){
		        		try{
	        				data = JSON.parse(data);
		        		}catch(e){
		        			console("Invalid json");
		        			if(tries < 6){
								setTimeout(checkStatus, 5000);
								tries++;
							}else{
								tries = 0;
							}
		        			return;
		        		}
		        		console.log("Response Status: " + JSON.stringify(data));
		        		if(Array.isArray(data)){
		        			console.log("Data is array");
							for(var i = 0; i < data.length; i++){
								if(data[i].ident == "service"){
									if(data[i].value < 4 && data[i].value >= 0){
										loadPanel.hide();
										tries = 0;
									}else{
										if(tries < 6){
											setTimeout(checkStatus, 5000);
											tries++;
										}else{
											tries = 0;
										}
									}
								}
							}
		        		}else{
							if(tries < 6){
								setTimeout(checkStatus, 5000);
								tries++;
							}else{
								tries = 0;
							}
		        		}

					}else{
							if(tries < 6){
								setTimeout(checkStatus, 5000);
								tries++;
							}else{
								tries = 0;
							}
					}
	  			}
	  		});	
		}else{

			$.ajax(
			{
				dataType: "json",
				url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=status&d=" + getStringNormalDate(d) + localStorage.getItem("TOKEN"),
				async: false,
				success: function(data)
				{
					for(var i = 0; i < data.length; i++){
						if(data[i].ident == "service"){
							if(data[i].value < 4 && data[i].value >= 0){
								loadPanel.hide();
								tries = 0;
							}else{
								if(tries < 6){
									setTimeout(checkStatus, 5000);
									tries++;
								}else{
									tries = 0;
								}
							}
						}
					}
				}
			});
		}
	}

	function startapp()
	{
		$.ajax(
		{
			url: pathcgi + "../cgi-bin/admin/vadpctrl.cgi?cmd=start&idx=" + ident + "&d=" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			success: function()
			{
				loadPanel.hide();
				DevExpress.ui.notify("Application restarted", "success", 600);
			}
		});
	}
	$("#icon-restart").dxButton(
	{
		type: "success",
		text: DevExpress.localization.formatMessage("Restart service"),
		onClick: function()
		{
			loadPanel.show();
			//lp = loadPanel;
			restartapp();
		}
	});
	
	if (DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA")
	{
		var saveopts = [DevExpress.localization.formatMessage("Manager"), DevExpress.localization.formatMessage("Service"), DevExpress.localization.formatMessage("Engine"), DevExpress.localization.formatMessage("Analytics")];
	}
	else
	{
		var saveopts = [DevExpress.localization.formatMessage("Manager"), DevExpress.localization.formatMessage("Service"), DevExpress.localization.formatMessage("Engine")];
	}
	var logrefresh;
	
	var timer;
	var exampleTextArea = $("#example-textarea").dxTextArea(
	{
		value: "",
		readOnly: true,
		height: 550
	}).dxTextArea("instance");
	var glogs = $("#glog").dxTextArea(
	{
		value: "",
		readOnly: true,
		height: 550
	}).dxTextArea("instance");
	var glogsengine = $("#glogsengine").dxTextArea(
	{
		value: "",
		readOnly: true,
		height: 550
	}).dxTextArea("instance");
	if (DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA")
	{
		var glogsanalytics = $("#glogsanalytics").dxTextArea(
		{
			value: "",
			readOnly: true,
			height: 550
		}).dxTextArea("instance");
	}
	var optlogs = -1;

	function timerfunc()
	{
		if (optlogs == 0)
		{
			jQuery.ajax(
			{
				async: false,
				url: pathcgi + 'cgi-bin/vparcgi.cgi?computerid=' + computerid + '&oper=cgilogs&d=' + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
				success: function(data)
				{
					CheckTokenValidity(data);
					exampleTextArea.option("value", data);
					exampleTextArea.option("readOnly", true);
				}
			});
		}
		if (optlogs == 1)
		{
			jQuery.ajax(
			{
				async: false,
				url: pathcgi + 'cgi-bin/vparcgi.cgi?computerid=' + computerid + '&oper=vpardlogs&d=' + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
				success: function(data)
				{
					CheckTokenValidity(data);
					glogs.option("value", data);
					glogs.option("readOnly", true);
				}
			});
		}
		if (optlogs == 2)
		{
			jQuery.ajax(
			{
				async: false,
				url: pathcgi + 'cgi-bin/vparcgi.cgi?computerid=' + computerid + '&oper=enginelogs&d=' + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
				success: function(data)
				{
					CheckTokenValidity(data);
					glogsengine.option("value", data);
					glogsengine.option("readOnly", true);
				}
			});
		}
		if (DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA")
		{
			if (optlogs == 3)
			{
				jQuery.ajax(
				{
					async: false,
					url: pathcgi + 'cgi-bin/vparcgi.cgi?computerid=' + computerid + '&oper=analyticslogs&d=' + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
					success: function(data)
					{
						CheckTokenValidity(data);
						glogsanalytics.option("value", data);
						glogsanalytics.option("readOnly", true);
					}
				});
			}
		}
		timer = setTimeout(timerfunc, logrefresh);
		var rr = $(".dx-texteditor-input");
		rr[0].scrollTop = rr[0].scrollHeight;
		rr[1].scrollTop = rr[1].scrollHeight;
		rr[2].scrollTop = rr[2].scrollHeight;
		if (DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA")
		{
			rr[3].scrollTop = rr[3].scrollHeight;
		}
	};
	function timerfuncHanwha()
	{
		if (optlogs == 0)
		{
			var msg1 = "";
			msg1 += "<GetSDK_APP_DATA>";
			msg1 += "<AppName>NeuralEdge</AppName>";	
			msg1 += "<Data>computerid=" + computerid + "|oper=cgilogs|adinfo=notvalue</Data>";	
			msg1 += "</GetSDK_APP_DATA>";

			$(this).sendCommandToServer({
				appname : appName,      
	  			async : false,      
				requestMessage:msg1,
				success : function(response) {
					var resData = response.Data; 
		        	if(resData!=undefined){

	  					console.log("Datos consulta: " + msg1);
						console.log("Respuesta : " + JSON.stringify(resData));
						console.log("Respuesta status: " + resData);
						if(resData!=undefined){
							CheckTokenValidity(resData);
							exampleTextArea.option("value", resData);
							exampleTextArea.option("readOnly", true);
						}
					}else{
					}
	  			}
	  		});	
		}
		if (optlogs == 1)
		{
			var msg1 = "";
			msg1 += "<GetSDK_APP_DATA>";
			msg1 += "<AppName>NeuralEdge</AppName>";	
			msg1 += "<Data>computerid=" + computerid + "|oper=vpardlogs|adinfo=notvalue</Data>";	
			msg1 += "</GetSDK_APP_DATA>";

			$(this).sendCommandToServer({
				appname : appName,      
	  			async : false,      
				requestMessage:msg1,
				success : function(response) {
					var resData = response.Data; 
		        	if(resData!=undefined){

	  					console.log("Datos consulta: " + msg1);
						console.log("Respuesta : " + JSON.stringify(resData));
						console.log("Respuesta status: " + resData);
						if(resData!=undefined){
							CheckTokenValidity(resData);
							glogs.option("value", resData);
							glogs.option("readOnly", true);
						}
					}else{
					}
	  			}
	  		});	
		}
		if (optlogs == 2)
		{
			var msg1 = "";
			msg1 += "<GetSDK_APP_DATA>";
			msg1 += "<AppName>NeuralEdge</AppName>";	
			msg1 += "<Data>computerid=" + computerid + "|oper=enginelogs|adinfo=notvalue</Data>";	
			msg1 += "</GetSDK_APP_DATA>";

			$(this).sendCommandToServer({
				appname : appName,      
	  			async : false,      
				requestMessage:msg1,
				success : function(response) {
					var resData = response.Data; 
		        	if(resData!=undefined){

	  					console.log("Datos consulta: " + msg1);
						console.log("Respuesta : " + JSON.stringify(resData));
						console.log("Respuesta status: " + resData);
						if(resData!=undefined){
							CheckTokenValidity(resData);
							glogsengine.option("value", resData);
							glogsengine.option("readOnly", true);
						}
					}else{
					}
	  			}
	  		});	
		}
		if (optlogs == 3)
		{
			var msg1 = "";
			msg1 += "<GetSDK_APP_DATA>";
			msg1 += "<AppName>NeuralEdge</AppName>";	
			msg1 += "<Data>computerid=" + computerid + "|oper=analyticslogs|adinfo=notvalue</Data>";	
			msg1 += "</GetSDK_APP_DATA>";

			$(this).sendCommandToServer({
				appname : appName,      
	  			async : false,      
				requestMessage:msg1,
				success : function(response) {
					var resData = response.Data; 
		        	if(resData!=undefined){

	  					console.log("Datos consulta: " + msg1);
						console.log("Respuesta : " + JSON.stringify(resData));
						console.log("Respuesta status: " + resData);
						if(resData!=undefined){
							CheckTokenValidity(resData);
							glogsanalytics.option("value", resData);
							glogsanalytics.option("readOnly", true);
						}
					}else{
					}
	  			}
	  		});	
		}
		
		timer = setTimeout(timerfuncHanwha, logrefresh);
		var rr = $(".dx-texteditor-input");
		rr[0].scrollTop = rr[0].scrollHeight;
		rr[1].scrollTop = rr[1].scrollHeight;
		rr[2].scrollTop = rr[2].scrollHeight;
		rr[3].scrollTop = rr[3].scrollHeight;
	};
	$("#rtypelogs").dxRadioGroup(
	{
		items: saveopts,
		layout: "horizontal",
		onValueChanged: function(e)
		{
			if (e.value == DevExpress.localization.formatMessage("Manager"))
			{
				optlogs = 0;
				document.getElementById('denglogs').style.visibility = 'visible';
				document.getElementById('denglogs').style.display = 'block';
				document.getElementById('dgenlogs').style.visibility = 'hidden';
				document.getElementById('dgenlogs').style.display = 'none';
				document.getElementById('logsengine').style.visibility = 'hidden';
				document.getElementById('logsengine').style.display = 'none';
				if (DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA")
				{
					document.getElementById('logsanalytics').style.visibility = 'hidden';
					document.getElementById('logsanalytics').style.display = 'none';
				}
				if(DEFINE_INTERFACE == "HANWHA"){
					var msg1 = "";
					msg1 += "<GetSDK_APP_DATA>";
					msg1 += "<AppName>NeuralEdge</AppName>";	
					msg1 += "<Data>computerid=" + computerid + "|oper=cgilogs|adinfo=notvalue</Data>";	
					msg1 += "</GetSDK_APP_DATA>";

					$(this).sendCommandToServer({
						appname : appName,      
			  			async : false,      
						requestMessage:msg1,
						success : function(response) {
							var resData = response.Data; 
				        	if(resData!=undefined){

			  					console.log("Datos consulta: " + msg1);
								console.log("Respuesta : " + JSON.stringify(resData));
								console.log("Respuesta status: " + resData);
								if(resData!=undefined){
									CheckTokenValidity(resData);
									exampleTextArea.option("value", resData);
								}
							}else{
							}
			  			}
			  		});	
				}else{
					jQuery.ajax(
					{
						url: pathcgi + 'cgi-bin/vparcgi.cgi?computerid=' + computerid + '&oper=cgilogs&d=' + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
						success: function(data)
						{
							CheckTokenValidity(data);
							exampleTextArea.option("value", data);
						}
					});
				}
			}
			if (e.value == DevExpress.localization.formatMessage("Service"))
			{
				optlogs = 1;
				document.getElementById('dgenlogs').style.visibility = 'visible';
				document.getElementById('dgenlogs').style.display = 'block';
				document.getElementById('denglogs').style.visibility = 'hidden';
				document.getElementById('denglogs').style.display = 'none';
				document.getElementById('logsengine').style.visibility = 'hidden';
				document.getElementById('logsengine').style.display = 'none';
				if (DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA")
				{
					document.getElementById('logsanalytics').style.visibility = 'hidden';
					document.getElementById('logsanalytics').style.display = 'none';
				}
				if(DEFINE_INTERFACE == "HANWHA"){

					var msg1 = "";
					msg1 += "<GetSDK_APP_DATA>";
					msg1 += "<AppName>NeuralEdge</AppName>";	
					msg1 += "<Data>computerid=" + computerid + "|oper=vpardlogs|adinfo=notvalue</Data>";	
					msg1 += "</GetSDK_APP_DATA>";

					$(this).sendCommandToServer({
						appname : appName,      
			  			async : false,      
						requestMessage:msg1,
						success : function(response) {
							var resData = response.Data; 
				        	if(resData!=undefined){

			  					console.log("Datos consulta: " + msg1);
								console.log("Respuesta : " + JSON.stringify(resData));
								console.log("Respuesta status: " + resData);
								if(resData!=undefined){
									CheckTokenValidity(resData);
									glogs.option("value", resData);
								}
							}else{
							}
			  			}
			  		});	

				}else{
						
					jQuery.ajax(
					{
						url: pathcgi + 'cgi-bin/vparcgi.cgi?computerid=' + computerid + '&oper=vpardlogs&d=' + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
						success: function(data)
						{
							CheckTokenValidity(data);
							glogs.option("value", data);
						}
					});

				}			}
			if (e.value == DevExpress.localization.formatMessage("Engine"))
			{
				optlogs = 2;
				document.getElementById('dgenlogs').style.visibility = 'hidden';
				document.getElementById('dgenlogs').style.display = 'none';
				document.getElementById('denglogs').style.visibility = 'hidden';
				document.getElementById('denglogs').style.display = 'none';
				document.getElementById('logsengine').style.visibility = 'visible';
				document.getElementById('logsengine').style.display = 'block';
				if (DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA")
				{
					document.getElementById('logsanalytics').style.visibility = 'hidden';
					document.getElementById('logsanalytics').style.display = 'none';
				}

				if(DEFINE_INTERFACE == "HANWHA"){
					var msg1 = "";
					msg1 += "<GetSDK_APP_DATA>";
					msg1 += "<AppName>NeuralEdge</AppName>";	
					msg1 += "<Data>computerid=" + computerid + "|oper=enginelogs|adinfo=notvalue</Data>";	
					msg1 += "</GetSDK_APP_DATA>";

					$(this).sendCommandToServer({
						appname : appName,      
			  			async : false,      
						requestMessage:msg1,
						success : function(response) {
							var resData = response.Data; 
				        	if(resData!=undefined){

			  					console.log("Datos consulta: " + msg1);
								console.log("Respuesta : " + JSON.stringify(resData));
								console.log("Respuesta status: " + resData);
								if(resData!=undefined){
									CheckTokenValidity(resData);
									glogsengine.option("value", resData);
								}
							}else{
							}
			  			}
			  		});	
				}else{
						
					jQuery.ajax(
					{
						url: pathcgi + 'cgi-bin/vparcgi.cgi?computerid=' + computerid + '&oper=enginelogs&d=' + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
						success: function(data)
						{
							CheckTokenValidity(data);
							glogsengine.option("value", data);
						}
					});
				}
			}
			if (DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA")
			{
				if (e.value == DevExpress.localization.formatMessage("Analytics"))
				{
					optlogs = 3;
					document.getElementById('dgenlogs').style.visibility = 'hidden';
					document.getElementById('dgenlogs').style.display = 'none';
					document.getElementById('denglogs').style.visibility = 'hidden';
					document.getElementById('denglogs').style.display = 'none';
					document.getElementById('logsengine').style.visibility = 'hidden';
					document.getElementById('logsengine').style.display = 'none';
					document.getElementById('logsanalytics').style.visibility = 'visible';
					document.getElementById('logsanalytics').style.display = 'block';
					if(DEFINE_INTERFACE == "HANWHA"){
						var msg1 = "";
						msg1 += "<GetSDK_APP_DATA>";
						msg1 += "<AppName>NeuralEdge</AppName>";	
						msg1 += "<Data>computerid=" + computerid + "|oper=analyticslogs|adinfo=notvalue</Data>";	
						msg1 += "</GetSDK_APP_DATA>";

						$(this).sendCommandToServer({
							appname : appName,      
				  			async : false,      
							requestMessage:msg1,
							success : function(response) {
								var resData = response.Data; 
					        	if(resData!=undefined){

				  					console.log("Datos consulta: " + msg1);
									console.log("Respuesta : " + JSON.stringify(resData));
									console.log("Respuesta status: " + resData);
									if(resData!=undefined){
										CheckTokenValidity(resData);
										glogsengine.option("value", resData);
									}
								}else{
								}
				  			}
				  		});	

					}else{
							
						jQuery.ajax(
						{
							url: pathcgi + 'cgi-bin/vparcgi.cgi?computerid=' + computerid + '&oper=analyticslogs&d=' + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
							success: function(data)
							{
								CheckTokenValidity(data);
								glogsanalytics.option("value", data);
							}
						});
					}
				}
			}
		}
	});
	$("#Autorefresh").dxCheckBox(
	{
		text: DevExpress.localization.formatMessage("Enabled"),
		onValueChanged: function(e)
		{
			if (e.value == true)
			{	
				if(DEFINE_INTERFACE == "HANWHA")
					timer = setTimeout(timerfuncHanwha, logrefresh);
				else
					timer = setTimeout(timerfunc, logrefresh);
			}
			else
			{
				clearTimeout(timer);
			}
		}
	});
	$("#icon-done_info").dxButton(
	{
		type: "success",
		text: DevExpress.localization.formatMessage("Download logs"),
		onClick: function()
		{
			if(DEFINE_INTERFACE == "HANWHA"){

			}else{
				
				window.location = pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getlogtgz" + localStorage.getItem("TOKEN");
			}
		}
	});
	$("#clear-logs").dxButton(
	{
		type: "success",
		text: DevExpress.localization.formatMessage("Clear logs"),
		onClick: function()
		{					
			if(DEFINE_INTERFACE == "HANWHA"){
					var msg1 = "";
					msg1 += "<GetSDK_APP_DATA>";
					msg1 += "<AppName>NeuralEdge</AppName>";	
					msg1 += "<Data>computerid=" + computerid + "|oper=clearlogs|adinfo=notvalue</Data>";	
					msg1 += "</GetSDK_APP_DATA>";

					$(this).sendCommandToServer({
						appname : appName,      
			  			async : false,      
						requestMessage:msg1,
						success : function(response) {
							var resData = response.Data; 
				        	if(resData!=undefined){

			  					console.log("Datos consulta: " + msg1);
								console.log("Respuesta : " + JSON.stringify(resData));
								console.log("Respuesta status: " + resData);
								if(resData!=undefined){
									CheckTokenValidity(resData);
									DevExpress.ui.notify(DevExpress.localization.formatMessage("OperationOK"), "success", 600);
								}
							}else{
							}
			  			}
			  		});	

			}else{
						
				jQuery.ajax(
				{
					async: true,
					url: pathcgi + 'cgi-bin/vparcgi.cgi?computerid=' + computerid + '&oper=clearlogs&d=' + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
					success: function(data)
					{
						CheckTokenValidity(data);
						DevExpress.ui.notify(DevExpress.localization.formatMessage("OperationOK"), "success", 600);
					}
				});
			}
		}
	});
});