///////////////
// LIVE PAGE //
///////////////

function getConfig(dict, dictlist){		
	var msgConf1 = "";
	msgConf1 += "<GetSDK_APP_DATA>";
	msgConf1 += "<AppName>NeuralEdge</AppName>";
	msgConf1 += "<Data>computerid=" + computerid + "|oper=getconfig1|adinfo=notvalue</Data>";	
	msgConf1 += "</GetSDK_APP_DATA>";
	addToQueue(msgConf1, function(response) {
		var config1 = response;
		config1 = config1.replace(/,,,,,,,,,,,/g, "");
		config1 = config1.replace(/,,,],[,]/g, "]");
		console.log("Respuesta status: " + config1);
		try {  
		  config1 = JSON.parse(config1); 
		} catch (e) {  
		  console.log('invalid json'); 
		  return; 
		}
		CheckTokenValidity(config1);
		if(Array.isArray(config1)){
			if(config1.length>0){
				$.each(config1[1], function(i, item)
				{
					dict[item.id] = item.description;
				});
				$.each(config1[0], function(i, item)
				{
					dictlist["[" + item.id + "]"] = item.description;
				});
			}
		}
	});

	var msgConf2 = "";
	msgConf2 += "<GetSDK_APP_DATA>";
	msgConf2 += "<AppName>NeuralEdge</AppName>";
	msgConf2 += "<Data>computerid=" + computerid + "|oper=getconfig2|adinfo=notvalue</Data>";	
	msgConf2 += "</GetSDK_APP_DATA>";
	addToQueue(msgConf2, function(response) {
		var config2 = response;
		config2 = config2.replace(/,,,,,,,,,,,/g, "");
		config2 = config2.replace(/,,,],[,]/g, "]");	
		console.log("Respuesta status: " + config2);
		try {  
		  config2 = JSON.parse(config2); 
		} catch (e) {  
		  console.log('invalid json'); 
		  return; 
		}				
		CheckTokenValidity(config2);
		if(Array.isArray(config2)){
			if(config2.length>0){
				$.each(config2[1], function(i, item)
				{
					dict[item.id] = item.description;
				});
				$.each(config2[0], function(i, item)
				{
					dictlist["[" + item.id + "]"] = item.description;
				});
			}
		}
	});
}
function getConfig2(dict, dictlist){		
	var msgConf1 = "";
	msgConf1 += "<GetSDK_APP_DATA>";
	msgConf1 += "<AppName>NeuralEdge</AppName>";
	msgConf1 += "<Data>computerid=" + computerid + "|oper=select|table=nllist|maxvalues=50|adinfo=notvalue</Data>";	
	msgConf1 += "</GetSDK_APP_DATA>";
	addToQueue(msgConf1, function(response) {
		var config1 = response;
		console.log("Respuesta status: " + config1);
		try {  
		  config1 = JSON.parse(config1); 
		} catch (e) {  
		  console.log('invalid json'); 
		  return; 
		}
		CheckTokenValidity(config1);
		if(Array.isArray(config1)){
			if(config1.length>0){
				$.each(config1[1], function(i, item)
				{
					dict[item.id] = item.description;
				});
				$.each(config1[0], function(i, item)
				{
					dictlist["[" + item.id + "]"] = item.description;
				});
			}
		}	
	});

	var msgConf2 = "";
	msgConf2 += "<GetSDK_APP_DATA>";
	msgConf2 += "<AppName>NeuralEdge</AppName>";
	msgConf2 += "<Data>computerid=" + computerid + "|oper=select|table=nlcountry|maxvalues=200|sortasc=description|adinfo=notvalue</Data>";	
	msgConf2 += "</GetSDK_APP_DATA>";
	addToQueue(msgConf2, function(response) {
		var config2 = response;
		console.log("Respuesta msgConf2: " + msgConf2);
		console.log("Respuesta status: " + config2);
		try {  
		  config2 = JSON.parse(config2); 
		} catch (e) {  
		  console.log('invalid json'); 
		  return; 
		}
		CheckTokenValidity(config2);
		if(Array.isArray(config2)){
			if(config2.length>0){
				$.each(config2[1], function(i, item)
				{
					dict[item.id] = item.description;
				});
				$.each(config2[0], function(i, item)
				{
					dictlist["[" + item.id + "]"] = item.description;
				});
			}
		}
	});

	var msgConf3 = "";
	msgConf3 += "<GetSDK_APP_DATA>";
	msgConf3 += "<AppName>NeuralEdge</AppName>";
	msgConf3 += "<Data>computerid=" + computerid + "|oper=select|table=nlactiontype|maxvalues=25|adinfo=notvalue</Data>";	
	msgConf3 += "</GetSDK_APP_DATA>";
	addToQueue(msgConf3, function(response) {
		var config3 = response;
		config3 = config3.replace(/,,,,,,,,,,,/g, "");
		console.log("Respuesta msgConf3: " + msgConf3);
		console.log("Respuesta status: " + config3);
		try {  
		  config3 = JSON.parse(config3); 
		} catch (e) {  
		  console.log('invalid json'); 
		  return; 
		}
		CheckTokenValidity(config3);
		if(Array.isArray(config3)){
			if(config3.length>0){
				$.each(config3[1], function(i, item)
				{
					dict[item.id] = item.description;
				});
				$.each(config3[0], function(i, item)
				{
					dictlist["[" + item.id + "]"] = item.description;
				});
			}
		}
	});

	var msgConf4 = "";
	msgConf4 += "<GetSDK_APP_DATA>";
	msgConf4 += "<AppName>NeuralEdge</AppName>";
	msgConf4 += "<Data>computerid=" + computerid + "|oper=select|table=nlexporttype|maxvalues=20|adinfo=notvalue</Data>";	
	msgConf4 += "</GetSDK_APP_DATA>";
	addToQueue(msgConf4, function(response) {
		var config4 = response;
		console.log("Respuesta status: " + config4);
		try {  
		  config4 = JSON.parse(config4); 
		} catch (e) {  
		  console.log('invalid json'); 
		  return; 
		}
		CheckTokenValidity(config4);
		if(Array.isArray(config4)){
			if(config4.length>0){
				$.each(config4[1], function(i, item)
				{
					dict[item.id] = item.description;
				});
				$.each(config4[0], function(i, item)
				{
					dictlist["[" + item.id + "]"] = item.description;
				});
			}
		}
	});

	var msgConf6 = "";
	msgConf6 += "<GetSDK_APP_DATA>";
	msgConf6 += "<AppName>NeuralEdge</AppName>";
	msgConf6 += "<Data>computerid=" + computerid + "|oper=select|table=nlimporttype|maxvalues=20|adinfo=notvalue</Data>";	
	msgConf6 += "</GetSDK_APP_DATA>";
	addToQueue(msgConf6, function(response) {
		var config5 = response;
		console.log("Respuesta status: " + config5);
		try {  
		  config5 = JSON.parse(config5); 
		} catch (e) {  
		  console.log('invalid json'); 
		  return; 
		}
		CheckTokenValidity(config5);
		if(Array.isArray(config5)){
			if(config5.length>0){
				$.each(config5[1], function(i, item)
				{
					dict[item.id] = item.description;
				});
				$.each(config5[0], function(i, item)
				{
					dictlist["[" + item.id + "]"] = item.description;
				});
			}
		}
	});

}

$(function()
{
	Init_translate();
	make_header("index");
	set_rcpopup();
	set_uppopup();
	var timer;
	var timer2;
	var timer3;
	var i = 0;
	var d1 = new Date();
	var d2 = new Date();
	var lastid = -1;
	var lastSquareResults = [];
	var images = [];
	var resx = 0;
	var resy = 0;
	var roitop = 0;
	var roileft = 0;
	var roiwidth = 0;
	var roiheight = 0;
	var widthdraw = 229;
	var heightdraw = 192;
	var index_peticion = 0;
	var wdefined = 691;
	var hdefined = 389;
	var capability_fisheye = "0";
	if (DEFINE_INTERFACE == "ZKTECO")
	{
		wdefined = 750; //650;
		hdefined = 430; //330;
	}
	var showroi = false;
	var roimessagedisplayed = false;
	var showlanes = false;
	var lanesmessagedisplayed = false;
	var showpattern = false;
	var showreallive = true;
	var showstatus = true;
	var showcrossline = false;
	var crosslinemessagedisplayed = false;
	var dateoverlay = false;
	if (DEFINE_INTERFACE == "VIVOTEK" || DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA")
	{
		var timestamp_vivotek = "0";
	}
	var viconresolution = false;
	var results = [];
	//lane variables
	var haveLanes = false;
	var p0 = 0;
	var p1 = 0;
	var ie = detectIE();
	var rtspURL = "";
	var rtspport = "554";
	var ws, rtspChannel;
	var liveview;
	//crossline variables
	var numCrossline = 0;
	var haveCrossline = false;
	var x0 = [0,0];
	var y0 = [0,0];
	var x1 = [0,0];
	var y1 = [0,0];
	var clarea1 = [0,0];
	var clarea2 = [0,0];
	var clarea3 = [0,0];
	var clarea4 = [0,0];
	String.prototype.includes = function(str)
	{
		var returnValue = false;
		if (this.indexOf(str) !== -1)
		{
			returnValue = true;
		}
		return returnValue;
	};
	var timerefreshImagen = 1000;
	var timerefreshInfo = 1000;
	var timerrefreshStatus = 1000;
	var timerautrorefresh = 1000 * 60 * 60;
	var debugoptions = false;
	var aplication;


	//Visibility Options
	var LaneVisible = false;
	var DirectionVisible = false;
	var SpeedVisible = false;
	var ConfVisible = false;
	var HeightVisible = false;
	var CountryVisible = false;
	var ListVisible = false;
	var ClassVisible = false;
	var ColorVisible = false;
	var MakeVisible = false;


	var visorType ="realtime";
	$.ajax(
	{
		dataType: "json",
		url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlconfgeneral&maxvalues=100&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
		async: false,
		success: function(data)
		{
			CheckTokenValidity(data);
			$.each(data, function(i, item)
			{
				if (item.name == "viewlive")
				{
					console.log("item: " + item);
					visorType = item.value;
				}
				if (item.name == "listfields")
				{
					console.log("item: " + JSON.stringify(item));
					LaneVisible = item.value.includes("Lane");
					DirectionVisible = item.value.includes("Direction");
					SpeedVisible = item.value.includes("Speed");
					ConfVisible = item.value.includes("Conf");
					HeightVisible = item.value.includes("Height");
					CountryVisible = item.value.includes("Country");
					ListVisible = item.value.includes("List");				
					ClassVisible = item.value.includes("Class");
					ColorVisible = item.value.includes("Color");
					MakeVisible = item.value.includes("Make");
				}
			});
		}
	});
	console.log(visorType);	
	if(DEFINE_INTERFACE == "HANWHA"){
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		var msg = "";
		msg += "<GetSDK_APP_DATA>";
		msg += "<AppName>NeuralEdge</AppName>";
		msg += "<Data>computerid=" + computerid + "|oper=select|table=nlconfgeneral|camp0=name|comp0=equal|value0=reviewfields|maxvalues=1|adinfo=notvalue</Data>";	
		msg += "</GetSDK_APP_DATA>";

		addToQueue(msg, function(response) {
				var resData = response; 
				console.log("Response in first query response: " + JSON.stringify(resData));
					console.log("Datos consulta: " + msg);
	        	if(resData!=undefined && resData!=""){
					try {  
					  resData = JSON.parse(resData); 
					} catch (e) {  
					  console.log('invalid json'); 
					  return; 
					}
					if(Array.isArray(resData)){
						LaneVisible = resData[0]["value"].includes("Lane");
						DirectionVisible = resData[0]["value"].includes("Direction");
						SpeedVisible = resData[0]["value"].includes("Speed");
						ConfVisible = resData[0]["value"].includes("Conf");
						HeightVisible = resData[0]["value"].includes("Height");
						CountryVisible = resData[0]["value"].includes("Country");
						ListVisible = resData[0]["value"].includes("List");
						ClassVisible = resData[0]["value"].includes("Class");
						ColorVisible = resData[0]["value"].includes("Color");
						MakeVisible = resData[0]["value"].includes("Make");
					}
				}    
    	}); 
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	var testFirstClick = true;
	function clickBody(){
		if (testFirstClick) {
			console.log("entro");
				if(!ie){

		var address = "ws://"+location.host;
	      var target = rtspURL;  // live.sdp, live2.sdp, live3.sdp
	     
	      var sid = "8523672543";

	      ws = new WebSocket(address + '/ws/module_over_ws', 'vvtk-protocol');

	      rtspChannel = new RTCRtspProtocol(ws);
	      ws.onopen = function (ev) {
	        ws.trigger('open', ev);

	        // step 1. create a Liveview instance
	     liveview = new Liveview({
	          url: 'rtsp://localhost/' + target,
	          rtspChannel: rtspChannel,
	          volume: 0,
	          mute: true,
	          username: 'admin',
	          sessionId: sid,
			  width:wdefined,
			  height:hdefined
	        });

	        // step 1.1 watch instance's event
	        liveview.on('play', function () {
	          console.log('play', 'liveview\'s video is playing');
	        });

	        liveview.on('notify', function (notify) {
	          // console.log('notify', notify.timestamp.stream);
	        });

	        // step 1.2 append the instance's video to the Document's body
			$("#field").find("video").remove();


			$("#field").prepend(liveview.video);
			$("video").css("width", wdefined+"px");
			$("video").css("height", hdefined+"px");
			liveview.play();
			console.log("Play: " + JSON.stringify(liveview));
		};
	}
			testFirstClick = false;
		};
	}
	if (visorType == "realtime")
	document.body.addEventListener("click", clickBody);
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	if (DEFINE_INTERFACE == "VIVOTEK" || DEFINE_INTERFACE == "VIVOTEK_CV25")
	{
		$.ajax(
		{
			dataType: "json",
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlconfgeneral&camp0=id&value0=0&camp1=value&maxvalues=250&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{	
				console.log("Test nlconfgeneral: " + JSON.stringify(data));
				CheckTokenValidity(data);
				aplication = data[0].value;
			}
		});
	}

	setTimeout(function()
	{
		location.reload(true);
	}, timerautrorefresh);
	
	$.urlParam = function(name)
	{
		var results = new RegExp('[\?&]' + name + '=([^&#]*)').exec(window.location.href);
		if (results == null)
		{
			return null;
		}
		else
		{
			return results[1] || 0;
		}
	}
	
	if ($.urlParam('debugoptions') != null && $.urlParam('debugoptions') == 1)
	{
		debugoptions = true;
	}
	

	if (visorType == "realtime")
	{
		var ua = window.navigator.userAgent;
		var msie = ua.indexOf("MSIE ");
		if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./))  // If Internet Explorer, return version number
		{
		}
		$.ajax({
	
			url: pathcgi + "../cgi-bin/viewer/getparam.cgi?network_rtsp_s0_accessname",
			async: false,
			success: function (data) {
				rtspURL= data.split("=")[1].split("'")[1];
			}
		});

		$.ajax({	
			url: pathcgi + "../cgi-bin/viewer/getparam.cgi?network_rtsp_port",
			async: false,
			success: function (data) {
				rtspport= data.split("=")[1].split("'")[1];
			}
		});
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	if(DEFINE_INTERFACE != "HANWHA"){
		if(!ie && visorType!= "getimage"){

			var address = "ws://"+location.host;
		    var target = rtspURL;  // live.sdp, live2.sdp, live3.sdp
		    // var target = "live.sdp";  // live.sdp, live2.sdp, live3.sdp
		     
		    var sid = "8523672543";

		    ws = new WebSocket(address + '/ws/module_over_ws', 'vvtk-protocol');

		    rtspChannel = new RTCRtspProtocol(ws);
		    console.log("Test rtspChannel" + JSON.stringify(rtspChannel));
		    ws.onopen = function (ev) {
		        ws.trigger('open', ev);

		        // step 1. create a Liveview instance
			   liveview = new Liveview({
			        url: 'rtsp://localhost/' + target,
			        rtspChannel: rtspChannel,
			        volume: 0,
			        mute: true,
			        username: 'admin',
			        sessionId: sid,
					width:wdefined,
					height:hdefined
			    });

			    // step 1.1 watch instance's event
			    liveview.on('play', function () {
			      console.log('play', 'liveview\'s video is playing');
			    });
			    liveview.on('notify', function (notify) {
			    // console.log('notify', notify.timestamp.stream);
			    });

			    // step 1.2 append the instance's video to the Document's body
			       
				$("#field").prepend(liveview.video);
				$("video").css("width", wdefined+"px");
				$("video").css("height", hdefined+"px");
				liveview.play();
				console.log("Play: " + JSON.stringify(liveview));
			};
			$("#field").append("<canvas id='canvas' style='margin:auto; position:relative; top : -"+(hdefined+5)+"px;' width='"+wdefined+"' height='"+hdefined+"'></canvas>");
		}
	}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	
	if (DEFINE_INTERFACE == "ZKTECO")
	{
		$.getScript("index.js");
		//Añadimos el review por js
		var htmlReview = "<div class='col_2' style='top: 75px; left: 800px;'>" +
			"<div class='dx-fieldset' style='margin: 0px 0px;'>" +
			"<div class='dx-field'>" +
			"<div class='dx-field-label' id='lbfromdate'>From date:</div>" +
			"<div class='dx-field-value'><div id='data1'></div></div>" +
			"</div>" +
			"<div class='dx-field'>" +
			"<div class='dx-field-label' id='lbtodate'>To date:</div>" +
			"<div class='dx-field-value'><div id='data2'></div></div>" +
			"</div>" +
			"<div class='dx-field' hidden>" +
			"<div class='dx-field-label'id= 'shnumreg' >Show num registers:</div>" +
			"<div class='dx-field-value'>" +
			"<div id='numreg'></div>" +
			"</div>" +
			"</div>" +
			"<div class='dx-field'>" +
			"<div class='dx-field-label' style=''><div id='icon-done_info'></div></div>" +
			"<div id='medium-indicator'></div>" +
			"</div>" +
			"</div>" +
			"</div>" +
			"<div class='col_2 no_margin_right' style='top: 75px; left: 1280px; float:right;'>" +
			"<div class='dx-fieldset' style='margin: 0px 0px;'>" +
			"<div class='dx-field'>" +
			"<div class='dx-field-label' id='lbplate'>Plate:</div>" +
			"<div class='dx-field-value'><div id='TxPlate'></div></div>" +
			"</div>" +
			"<div class='dx-field'>" +
			"<div class='dx-field-label' id='lblist'>List:</div>" +
			"<div class='dx-field-value'><div id='radio-group-simple'></div></div>" +
			"</div>" +
			"<div class='dx-field' style='padding: 0px 0px 0px 0;'>" +
			"<div class='dx-field-label' style='float: right;width: auto;    padding: 8px 0px 9px 0;'>" +
			//"<div id='Pag-indicator'></div>"+
			//"<div id='paginitas' style=''></div>"+
			"<div id='FirstPage'></div>" +
			"<div id='PageAnt' style=''></div>" +
			"<div id='PageSig' style=''></div>" +
			"<div id='LastPage' style=''></div>" +
			"<div id='export' style=''></div>" +
			"</div>" +
			"</div>" +
			"</div>" +
			"</div>" +
			"<div class='content_wrapper' style='top: 320px; left: 830px; width:100%'>" +
			"<div class='demo-container'><div id='gridContainerReview'></div></div>" +
			"</div>";
		//$("#field").append("<div id = 'gridstatus' style='position:absolute; top: 320px; left: 300px; max-width: 500px;'></div>");
		$("#field").append("<div><canvas id='canvas' style='top: 100px; left: 450px;' width='" + wdefined + "' height='" + hdefined + "'></canvas></div>");
		$("#field2").append(htmlReview);
	}
	else
	{
		if(visorType == "getimage"){
			$("#field").append("<canvas id='canvas' style='margin:auto;' width='" + wdefined + "' height='" + hdefined + "'></canvas>");
		}
		$("#field2").append("<div id = 'gridstatus' style='float:right;max-width: 450px;'></div>");
		$("#StatusAttr").remove();
	}
	if ((DEFINE_INTERFACE == "VIVOTEK"  || DEFINE_INTERFACE == "VIVOTEK_CV25") && (aplication == "eVivotek"))
	{
		if(visorType == "getimage"){
			var checks = "<div id='shwRLIVE' style='float: left;margin-right: 10px;margin-top: 10px;' ></div>" +
				"<div id='shwESTATUS' style='float: left;margin-right: 5px;margin-top: 10px;margin-left: 10px;' ></div>" +
				"<div id='shwROI' style='float: left;margin-right: 5px;margin-top: 10px;margin-left: 10px;' ></div>" +
				"<div id='shwLNS' style='float: left;margin-right: 10px;margin-top: 10px;margin-left: 10px;' ></div>" +
				"<div id='shwGUI' style='float: left;margin-right: 5px;margin-top: 10px;margin-left: 0px;' ></div>";
		}else{
			var checks = "<div style='margin-top: -390px;'><div id='shwRLIVE' style='margin-right: 10px;margin-top: -" + hdefined + "px;' ></div>" +
				"<div id='shwESTATUS' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwROI' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwLNS' style='margin-right: 10px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwGUI' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 0px;' ></div></div>";
		}
	}else if(DEFINE_INTERFACE == "HANWHA"){

		var checks = "<div style='margin-top: -390px;'><div id='shwRLIVE' style='margin-right: 10px;margin-top: -" + hdefined + "px;' ></div>" +
				"<div id='shwESTATUS' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwROI' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwLNS' style='margin-right: 10px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwGUI' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 0px;' ></div></div>";

		var serverName	= window.location.hostname;
    	var serverType = "http://";
    	var extention = "/livemjpeg";
        var liveStreamURI = serverType + serverName + ":1234" + extention;
		$("#field").append("<img id='streaming_uri' style='margin:auto;' width='" + wdefined + "' height='" + hdefined + "' src='"+liveStreamURI+"'>");
		$("#field").append("<canvas id='canvas' style='margin:auto; position:relative; top : -"+(hdefined+5)+"px;' width='"+wdefined+"' height='"+hdefined+"'></canvas>");
		// <img id="streaming_uri" width="640" height="360" src="http://213.195.119.4:8080/livemjpeg">
	}
	else if ((DEFINE_INTERFACE == "VIVOTEK_CV25") && (aplication == "eVivotek"))
	{
		if(visorType == "getimage"){
			var checks = "<div id='shwRLIVE' style='float: left;margin-right: 10px;margin-top: 10px;' ></div>" +
				"<div id='shwESTATUS' style='float: left;margin-right: 5px;margin-top: 10px;margin-left: 10px;' ></div>" +
				"<div id='shwROI' style='float: left;margin-right: 5px;margin-top: 10px;margin-left: 10px;' ></div>" +
				"<div id='shwLNS' style='float: left;margin-right: 10px;margin-top: 10px;margin-left: 10px;' ></div>" +
				"<div id='shwGUI' style='float: left;margin-right: 5px;margin-top: 10px;margin-left: 0px;' ></div>";
		}else{
			var checks = "<div style='margin-top: -390px;'><div id='shwRLIVE' style='margin-right: 10px;margin-top: -" + hdefined + "px;' ></div>" +
				"<div id='shwESTATUS' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwROI' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwLNS' style='margin-right: 10px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwGUI' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 0px;' ></div></div>";
		}
	}else{
		if(visorType == "getimage"){
		var checks = "<div id='shwRLIVE' style='float: left;margin-right: 10px;margin-top: 10px;' ></div>" +
			"<div id='shwESTATUS' style='float: left;margin-right: 5px;margin-top: 10px;margin-left: 10px;' ></div>" +
			"<div id='shwROI' style='float: left;margin-right: 5px;margin-top: 10px;margin-left: 10px;' ></div>" +
			"<div id='shwLNS' style='float: left;margin-right: 10px;margin-top: 10px;margin-left: 10px;' ></div>" +
			"<div id='shwGUI' style='float: left;margin-right: 5px;margin-top: 10px;margin-left: 0px;' ></div>" +
			"<div id='shwCROSS' style='float: left;margin-right: 10px;margin-top: 10px;' ></div>";
		}else{
			var checks = "<div style='margin-top: -390px;'><div id='shwRLIVE' style='margin-right: 10px;margin-top: -" + hdefined + "px;' ></div>" +
				"<div id='shwESTATUS' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwROI' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwLNS' style='margin-right: 10px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwGUI' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 0px;' ></div>"+
				"<div id='shwCROSS' style='float: left;margin-right: 10px;margin-top: 10px;' ></div>";
		}
	}
	console.log("checks: " + checks);
	$("#field").append(checks);

	function reDrawCanvas(){
		var canvas = document.getElementById('canvas');
		var ctx = canvas.getContext('2d');

		if (showroi && !viconresolution)
		{
			if (roiwidth != 0)
			{
				ctx.beginPath();
				var ppcX = parseFloat("0." + roileft);
				var ppcY = parseFloat("0." + roitop);
				var ppcwidth = parseFloat("0." + roiwidth);
				var ppcheight = parseFloat("0." + roiheight);
				ctx.rect(ppcX * wdefined, ppcY * hdefined, ppcwidth * wdefined, ppcheight * hdefined);
				ctx.strokeStyle = 'red';
				ctx.lineWidth = 5;
				ctx.stroke();
			}
		}

		if (showlanes && !viconresolution)
		{
			if (haveLanes)
			{
				ctx.beginPath();
				ctx.strokeStyle = 'blue';
				ctx.lineWidth = 2;
				ctx.moveTo(p0, 0);
				ctx.lineTo(p1, hdefined);
				ctx.stroke();
			}
		}

		if (showpattern && !viconresolution)
		{
			var linedraw = Math.round((25 * hdefined) / resy);
			ctx.beginPath();
			ctx.strokeStyle = 'white';
			ctx.lineWidth = 2;
			for (i = 0; i < hdefined; i += linedraw)
			{
				ctx.moveTo(0, i);
				ctx.lineTo(wdefined, i);
				ctx.stroke();
			}
		}

	}
	$("#shwROI").dxCheckBox(
	{
		value: false,
		text: DevExpress.localization.formatMessage("Show Roi"),
		onValueChanged: function(data)
		{
			showroi = data.value;
			if (data.value == false)
			{
				roimessagedisplayed = false;
			}

			if (visorType == "realtime") {
				var canvas = document.getElementById('canvas');
				var ctx = canvas.getContext('2d');

				if (showroi && !viconresolution)
				{
					if (roiwidth != 0)
					{
						reDrawCanvas();
					}
					else if (roimessagedisplayed == false)
					{
						DevExpress.ui.notify(DevExpress.localization.formatMessage("No ROI to display"), "info", 1000);
						roimessagedisplayed = true;
					}
				}else{
					ctx.clearRect(0, 0, wdefined, hdefined);
					reDrawCanvas();
				}
			}
		}
	});
	$("#shwLNS").dxCheckBox(
	{
		value: false,
		text: DevExpress.localization.formatMessage("Show lanes"),
		onValueChanged: function(data)
		{
			showlanes = data.value;
			if (data.value == false)
			{
				lanesmessagedisplayed = false;
			}


			if (visorType == "realtime") {
				var canvas = document.getElementById('canvas');
				var ctx = canvas.getContext('2d');

				if (showlanes && !viconresolution)
				{
					if (haveLanes)
					{
						reDrawCanvas();
					}
					else if (lanesmessagedisplayed == false)
					{
						DevExpress.ui.notify(DevExpress.localization.formatMessage("No lanes to display"), "info", 1000);
						lanesmessagedisplayed = true;
					}
				}else{
					ctx.clearRect(0, 0, wdefined, hdefined);
					reDrawCanvas();
				}
			}


		}
	});
	$("#shwGUI").dxCheckBox(
	{
		value: false,
		text: DevExpress.localization.formatMessage("Calibration pattern"),
		onValueChanged: function(data)
		{
			showpattern = data.value;
			if (visorType == "realtime") {
				var canvas = document.getElementById('canvas');
				var ctx = canvas.getContext('2d');

				if (showpattern && !viconresolution)
				{
					reDrawCanvas();
				}else{
					ctx.clearRect(0, 0, wdefined, hdefined);
					reDrawCanvas();
				}
			}
		}
	});
	$("#shwRLIVE").dxCheckBox(
	{
		value: true,
		text: DevExpress.localization.formatMessage("Show Real Live"),
		onValueChanged: function(data)
		{
			showreallive = data.value;
			if (data.value)
			{
				$("#gridContainer > .dx-datagrid").css("background-color", "white");
				$("#mat0").removeClass('gris');
				$("#mat1").removeClass('gris');
				$("#mat2").removeClass('gris');
				$("#mat3").removeClass('gris');
				$("#mat4").removeClass('gris');
				$("#mat0").addClass('demo-dark');
				$("#mat1").addClass('demo-dark');
				$("#mat2").addClass('demo-dark');
				$("#mat3").addClass('demo-dark');
				$("#mat4").addClass('demo-dark');
			}
			else
			{
				$("#gridContainer > .dx-datagrid").css("background-color", "#c6c8ca");
				$("#mat0").removeClass('demo-light');
				$("#mat0").removeClass('demo-dark');
				$("#mat1").removeClass('demo-light');
				$("#mat1").removeClass('demo-dark');
				$("#mat2").removeClass('demo-light');
				$("#mat2").removeClass('demo-dark');
				$("#mat3").removeClass('demo-light');
				$("#mat3").removeClass('demo-dark');
				$("#mat4").removeClass('demo-light');
				$("#mat4").removeClass('demo-dark');
				$("#mat0").addClass('gris');
				$("#mat1").addClass('gris');
				$("#mat2").addClass('gris');
				$("#mat3").addClass('gris');
				$("#mat4").addClass('gris');
			}
		}
	});
	$("#shwESTATUS").dxCheckBox(
	{
		value: true,
		text: DevExpress.localization.formatMessage("Show status"),
		onValueChanged: function(data)
		{
			showstatus = data.value;
			if (DEFINE_INTERFACE == "ZKTECO")
			{
				$("#StatusAttrTable").css("background-color", showstatus ? "white" : "#c6c8ca");
			}
			else
			{
				if (data.value)
				{
					$("#gridstatus > .dx-datagrid").css("background-color", "white");
				}
				else
				{
					$("#gridstatus > .dx-datagrid").css("background-color", "#c6c8ca");
				}
			}
		}
	});
	$("#shwCROSS").dxCheckBox(
	{
		value: false,
		text: DevExpress.localization.formatMessage("Show Cross Line"),
		onValueChanged: function(data)
		{
			showcrossline = data.value;
			if (data.value == false)
			{
				crosslinemessagedisplayed = false;
			}
		}
	});
	var dict = {};
	var dictlist = {};
	var status = [];
	
	//GET TIME
	if(DEFINE_INTERFACE == "HANWHA"){
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		var msg = "";
		msg += "<GetSDK_APP_DATA>";
		msg += "<AppName>NeuralEdge</AppName>";
		msg += "<Data>computerid=" + computerid + "|oper=gettime|adinfo=notvalue</Data>";	
		msg += "</GetSDK_APP_DATA>";


		addToQueue(msg, function(response) {
				var resData = response; 
		    	if(resData!=undefined && resData!=""){
					console.log("Datos consulta: " + msg);
					console.log("Respuesta : " + JSON.stringify(resData));
					console.log("Respuesta status: " + resData);

					CheckTokenValidity(resData);
					d2 = new Date(resData);
					d2.setMinutes(d2.getMinutes() - 5);
				}   
    	}); 
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


	}else{
		$.ajax(
		{
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=gettime&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{
				CheckTokenValidity(data);
				d2 = new Date(data);
				d2.setMinutes(d2.getMinutes() - 5);
			}
		});

	}

	function loadStatusValues()
	{
		status.forEach(function(info, elem)
		{
			var title = DevExpress.localization.formatMessage(info.text);
			if (info.ident == "service")
			{
				var ee = info.text.split(";")
				if (ee.length > 1)
				{
					title = DevExpress.localization.formatMessage(ee[0]) + ee[1];
				}
				else
				{
					title = DevExpress.localization.formatMessage(info.text);
				}
			}
			var value = info.value;
			if (info.ident == "service")
			{
				if (info.value == "-1")
				{
					value = "STOPPED";
				}
				if (info.value == "0")
				{
					value = "NO LICENSE";
				}
				if (info.value == "1")
				{
					value = "TRIGGER";
				}
				if (info.value == "2")
				{
					value = "FREEFLOW";
				}
				if (info.value == "3")
				{
					value = "MOTION";
				}
				if (info.value == "4")
				{
					value = "LOADING";
				}
			}
			var lastchange = new Date(info.lastchange);
			//HH:mm:ss.SSS dd/MM/yyyy
			var formatTime = "";
			if (lastchange)
			{
				formatTime += ("0" + lastchange.getHours()).slice(-2);
				formatTime += ":";
				formatTime += ("0" + lastchange.getMinutes()).slice(-2);
				formatTime += ":";
				formatTime += ("0" + lastchange.getSeconds()).slice(-2);
				formatTime += ".";
				formatTime += ("00" + lastchange.getMilliseconds()).slice(-3);
				formatTime += " ";
				formatTime += ("0" + lastchange.getDate()).slice(-2);
				formatTime += "/";
				formatTime += ("0" + (lastchange.getMonth() + 1)).slice(-2);
				formatTime += "/";
				formatTime += lastchange.getFullYear();
			}
			if ($("#StatusAttr" + elem + "Text").length != 0)
			{
				$("#StatusAttr" + elem + "Text").text(title);
			}
			if ($("#StatusAttr" + elem + "Value").length != 0)
			{
				$("#StatusAttr" + elem + "Value").text(value);
			}
			if ($("#StatusAttr" + elem + "Time").length != 0)
			{
				$("#StatusAttr" + elem + "Time").text(formatTime);
			}
			$("#StatusAttr" + elem + "Text").removeClass('Yellow');
			$("#StatusAttr" + elem + "Value").removeClass('Red');
			if ((info.ident == "SD" || info.ident == "CAMERA") && value <= 15 && value > 5)
			{
				$("#StatusAttr" + elem + "Text").addClass('Yellow');
				$("#StatusAttr" + elem + "Value").addClass('Yellow');
			}
			if ((info.ident == "SD" || info.ident == "CAMERA") && value <= 5)
			{
				$("#StatusAttr" + elem + "Text").addClass('Red');
				$("#StatusAttr" + elem + "Value").addClass('Red');
			}
			if (info.ident == "service" && value < 1)
			{
				$("#StatusAttr" + elem + "Text").addClass('Red');
				$("#StatusAttr" + elem + "Value").addClass('Red');
			}
			if (info.ident == "service" && value == 4)
			{
				$("#StatusAttr" + elem + "Text").addClass('Yellow');
				$("#StatusAttr" + elem + "Value").addClass('Yellow');
			}
			if (info.ident == "vicon_resolution")
			{
				if (info.value == "0")
				{
					value = "OK";
				}
				if (info.value == "1")
				{
					value = "NOT OK";
					$("#StatusAttr" + elem + "Text").addClass('Red');
					$("#StatusAttr" + elem + "Value").addClass('Red');
				}
			}
		});
	}
	$.urlParam = function(name)
	{
		var results = new RegExp('[\?&]' + name + '=([^&#]*)').exec(window.location.href);
		if (results == null)
		{
			return null;
		}
		else
		{
			return results[1] || 0;
		}
	}

	function loadStatus()
	{
		var d = new Date();

		if(DEFINE_INTERFACE == "HANWHA"){
			if(showHamwhaRes){
				/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				var msg = "";
				msg += "<GetSDK_APP_DATA>";
				msg += "<AppName>NeuralEdge</AppName>";
				msg += "<Data>computerid=" + computerid + "|oper=status|adinfo=notvalue</Data>";	
				msg += "</GetSDK_APP_DATA>";

				
				addToQueue(msg, function(response) {
					var resData = response; 
					// console.log("Response in first query response: " + JSON.stringify(resData));
  			// 		console.log("Datos consulta: " + msg);
					// console.log("Respuesta : " + JSON.stringify(resData));
					// console.log("Respuesta status: " + resData);
		        	if(resData!=undefined && resData!=""){
						// var lastChar = resData.substr(resData.length - 1);
						// console.log("Last char: " + lastChar);
						// if(resData.length > 3 && lastChar != "]"){
						// 	resData = resData + '"}]';
						// }
						//console.log("resData + lastChar: " + resData);
						try {  
						  resData = JSON.parse(resData); 
						} catch (e) {  
						  console.log('invalid json'); 
						  return; 
						}
						console.log("Response in first query Data: " + JSON.stringify(resData));
						//resData = resData.status;
						CheckTokenValidity(resData);
						if (debugoptions)
						{
							console.log("STATUS RESULT debugoptions: " + JSON.stringify(resData));
							status = resData;
						}
						else
						{
							status = jQuery.grep(resData, function(value)
							{
								console.log("STATUS RESULT GREP: " + JSON.stringify(value));
								return value.ident != "fps" && value.ident != "lasttime" && value.ident != "lastmotion" && value.ident != "queuesize" && value.ident != "framesdropped" && value.ident != "motion_noplates";
							});
						}
					}
		    	}); 
			
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			}		
		}else{
			$.ajax(
			{
				dataType: "json",
				url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=status&d=" + getStringNormalDate(d) + localStorage.getItem("TOKEN"),
				async: false,
				success: function(data)
				{
					CheckTokenValidity(data);
					if (debugoptions)
					{
						status = data;
					}
					else
					{
						if (DEFINE_INTERFACE == "VIVOTEK" || DEFINE_INTERFACE == "AXIS" || DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA")
						{
							status = jQuery.grep(data, function(value)
							{
								return value.ident != "fps" && value.ident != "lasttime" && value.ident != "lastmotion" && value.ident != "queuesize" && value.ident != "framesdropped" && value.ident != "motion_noplates" && value.ident != "lastBRnumber" && value.ident != "lastBRtime";
							});
						}
						else if (DEFINE_INTERFACE == "VICON")
						{
							status = jQuery.grep(data, function(value)
							{
								return value.ident != "fps" && value.ident != "lasttime" && value.ident != "lastmotion" && value.ident != "queuesize" && value.ident != "framesdropped" && value.ident != "motion_noplates" && value.ident != "vicon_resolution" && value.ident != "lastBRnumber" && value.ident != "lastBRtime";
							});
						}
						else
						{
							status = data;
						}
					}
					//status = data;
					if (DEFINE_INTERFACE == "ZKTECO")
					{
						loadStatusValues();
					}
				}
			});
		}
	}
	
	//GET COUNTRY
	console.log("TEST getconfig1" );

	if(DEFINE_INTERFACE == "HANWHA"){
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		getConfig2(dict, dictlist);
		// var msgConf1 = "";
		// msgConf1 += "<GetSDK_APP_DATA>";
		// msgConf1 += "<AppName>NeuralEdge</AppName>";
		// msgConf1 += "<Data>computerid=" + computerid + "|oper=getconfig1|adinfo=notvalue</Data>";	
		// msgConf1 += "</GetSDK_APP_DATA>";

		// $(this).sendCommandToServer({
		// 	appname : appName,      
  			      
		// 	requestMessage:msgConf1,
		// 	success : async function(response) {
		// 		var resData = response.Data; 
	 //        	if(resData!=undefined && resData!=""){

  // 					console.log("Datos consulta: " + msgConf1);
		// 			console.log("Respuesta : " + JSON.stringify(resData));
		// 			resData = resData.replace(/,,,,,,,,,,,/g, "");
		// 			resData = resData.replace(/,,,],[,]/g, "]");
		// 			console.log("Respuesta status: " + resData);
		// 			try {  
		// 			  resData = JSON.parse(resData); 
		// 			} catch (e) {  
		// 			  console.log('invalid json'); 
		// 			  return; 
		// 			}
		// 			CheckTokenValidity(resData);
		// 			if(Array.isArray(resData)){
		// 				if(resData.length>0){
		// 					$.each(resData[1], function(i, item)
		// 					{
		// 						dict[item.id] = item.description;
		// 					});
		// 					$.each(resData[0], function(i, item)
		// 					{
		// 						dictlist["[" + item.id + "]"] = item.description;
		// 					});
		// 				}
		// 			}
		// 		}    
		// 	}	
  //   	}); 
		// var msgConf2 = "";
		// msgConf2 += "<GetSDK_APP_DATA>";
		// msgConf2 += "<AppName>NeuralEdge</AppName>";
		// msgConf2 += "<Data>computerid=" + computerid + "|oper=getconfig2|adinfo=notvalue</Data>";	
		// msgConf2 += "</GetSDK_APP_DATA>";

		// $(this).sendCommandToServer({
		// 	appname : appName,      
  			      
		// 	requestMessage:msgConf2,
		// 	success : async function(response) {
		// 		var resData = response.Data; 
	 //        	if(resData!=undefined && resData!=""){

  // 					console.log("Datos consulta: " + msgConf1);
		// 			console.log("Respuesta : " + JSON.stringify(resData));
		// 			console.log("Respuesta status: " + resData);
		// 			try {  
		// 			  resData = JSON.parse(resData); 
		// 			} catch (e) {  
		// 			  console.log('invalid json'); 
		// 			  return; 
		// 			}
		// 			CheckTokenValidity(resData);
		// 			if(Array.isArray(resData)){
		// 				if(resData.length>0){
		// 					$.each(resData[1], function(i, item)
		// 					{
		// 						dict[item.id] = item.description;
		// 					});
		// 					$.each(resData[0], function(i, item)
		// 					{
		// 						dictlist["[" + item.id + "]"] = item.description;
		// 					});
		// 				}
		// 			}
		// 		}    
		// 	}	
  //   	}); 
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	}else{
		$.ajax(
		{
			dataType: "json",
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getconfig&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{
				CheckTokenValidity(data);
				$.each(data[1], function(i, item)
				{
					dict[item.id] = item.description;
				});
				$.each(data[0], function(i, item)
				{
					dictlist["[" + item.id + "]"] = item.description;
				});
			}
		});
	}

	// GET RESOLUTION

	if(DEFINE_INTERFACE == "HANWHA"){
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		var msg = "";
		msg += "<GetSDK_APP_DATA>";
		msg += "<AppName>NeuralEdge</AppName>";
		msg += "<Data>computerid=" + computerid + "|oper=select|table=nlconfcamera|camp0=id|comp0=minor|value0=60|maxvalues=100|adinfo=notvalue</Data>";	
		msg += "</GetSDK_APP_DATA>";

		
		addToQueue(msg, function(response) {
			var data = response; 
        	if(data!=undefined && data!=""){
					console.log("Datos consulta: " + msg);
				console.log("Respuesta : " + JSON.stringify(data));
				console.log("Respuesta status: " + data);
				data = data.replace(/,,/g, "");
				data = data.replace(/\},]/g, "\}]");
				try {  
				  data = JSON.parse(data); 
				} catch (e) {  
				  console.log('invalid json'); 
				  return; 
				}

				CheckTokenValidity(data);
				if(Array.isArray(data)){
					if(data.length>0){
						$.each(data, function(i, item)
						{
							if (item.id == 57)
							{
								if (item.name.includes("umresolution"))
								{
									var resopt = item.value.split("x");
									resx = resopt[0];
									resy = resopt[1];
								}
							}
							if (item.id == 5)
							{
								var resopt = item.value.split(";");
								roileft = resopt[0];
								roitop = resopt[1];
								roiwidth = resopt[2];
								roiheight = resopt[3];
							}
						});
					}
				}  
			}
    	}); 
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	}else{
		$.ajax(
		{
			dataType: "json",
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlconfcamera&camp0=id&comp0=minor&value0=100&maxvalues=100&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{
				CheckTokenValidity(data);
				$.each(data, function(i, item)
				{
					if (item.id == 57)
					{
						if (item.name.includes("umresolution"))
						{
							var resopt = item.value.split("x");
							resx = resopt[0];
							resy = resopt[1];
						}
					}
					if (item.id == 5)
					{
						var resopt = item.value.split(";");
						roileft = resopt[0];
						roitop = resopt[1];
						roiwidth = resopt[2];
						roiheight = resopt[3];
					}
				});
			}
		});
	}
	
	//GET LANES

	if(DEFINE_INTERFACE == "HANWHA"){
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		var msg = "";
		msg += "<GetSDK_APP_DATA>";
		msg += "<AppName>NeuralEdge</AppName>";
		msg += "<Data>computerid=" + computerid + "|oper=select|table=nlcameralane|camp0=id|comp0=minor|value0=100|maxvalues=100|adinfo=notvalue</Data>";	
		msg += "</GetSDK_APP_DATA>";

		addToQueue(msg, function(response) {
			var data = response; 
        	if(data!=undefined && data!=""){
					console.log("Datos consulta: " + msg);
				console.log("Respuesta : " + JSON.stringify(data));
				console.log("Respuesta status: " + data);
				try {  
				  data = JSON.parse(data); 
				} catch (e) {  
				  console.log('invalid json'); 
				  return; 
				}

				CheckTokenValidity(data);
				if(Array.isArray(data)){
					if(data.length>0){
						haveLanes = true;
						p0 = parseFloat(data[0].lpoint00X / 10000) * wdefined;
						p1 = parseFloat(data[0].lpoint01X / 10000) * wdefined;
					}
				}
			}	   
    	}); 
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	}else{
		$.ajax(
		{
			dataType: "json",
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlcameralane&maxvalues=2&dd=" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{
				CheckTokenValidity(data);
				if (data.length > 0)
				{
					haveLanes = true;
					p0 = parseFloat(data[0].lpoint00X / 10000) * wdefined;
					p1 = parseFloat(data[0].lpoint01X / 10000) * wdefined;
				}
			}
		});
	}
	
	//GET CROSSLINE

	if(DEFINE_INTERFACE == "HANWHA"){
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		var msg = "";
		msg += "<GetSDK_APP_DATA>";
		msg += "<AppName>NeuralEdge</AppName>";
		msg += "<Data>computerid=" + computerid + "|oper=select|table=nlcrossline|camp0=id|comp0=minor|value0=100|maxvalues=100|adinfo=notvalue</Data>";	
		msg += "</GetSDK_APP_DATA>";

		addToQueue(msg, function(response) {
				var data = response; 
	        	if(data!=undefined && data!=""){
  					console.log("Datos consulta: " + msg);
					console.log("Respuesta : " + JSON.stringify(data));
					console.log("Respuesta status: " + data);
					try {  
					  data = JSON.parse(data); 
					} catch (e) {  
					  console.log('invalid json'); 
					  return; 
					}

					CheckTokenValidity(data);
					if(Array.isArray(data)){
						if(data.length>0){
							haveLanes = true;
							p0 = parseFloat(data[0].lpoint00X / 10000) * wdefined;
							p1 = parseFloat(data[0].lpoint01X / 10000) * wdefined;
						}
					}    
				}
    	}); 
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	}else{
		$.ajax(
		{
			dataType: "json",
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlcrossline&maxvalues=8&dd=" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{
				CheckTokenValidity(data);
				numCrossline = data.length;
				if (numCrossline > 0)
				{
					haveCrossline = true;
					for (var i=0; i<numCrossline; i++)
					{
						x0[i] = parseFloat(data[i].lineX0) * wdefined;
						y0[i] = parseFloat(data[i].lineY0) * hdefined;
						x1[i] = parseFloat(data[i].lineX1) * wdefined;
						y1[i] = parseFloat(data[i].lineY1) * hdefined;
						clarea1[i] = parseFloat(data[i].roi1) * wdefined;
						clarea2[i] = parseFloat(data[i].roi2) * hdefined;
						clarea3[i] = parseFloat(data[i].roi3) * wdefined;
						clarea4[i] = parseFloat(data[i].roi4) * hdefined;
					}
				}
			}
		});
	}
	
	//GET DATE OVERLAY
	if(DEFINE_INTERFACE == "HANWHA"){
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		var msg = "";
		msg += "<GetSDK_APP_DATA>";
		msg += "<AppName>NeuralEdge</AppName>";
		msg += "<Data>computerid=" + computerid + "|oper=select|table=nlconfgeneral|camp0=id|comp0=minor|value0=60|maxvalues=100|adinfo=notvalue</Data>";	
		msg += "</GetSDK_APP_DATA>";

		
		addToQueue(msg, function(response) {
			var data = response; 
        	if(data!=undefined && data!=""){
					console.log("Datos consulta: " + msg);
				console.log("Respuesta : " + JSON.stringify(data));
				console.log("Respuesta status: " + data);

				data = data.replace(/,,/g, "");
				data = data.replace(/\},]/g, "\}]");
				data = JSON.parse(data);

				CheckTokenValidity(data);
				if(Array.isArray(data)){
					if(data.length>0){
						$.each(data, function(i, item)
						{
							if (item.id == 55)
							{
								if (item.value == "true")
								{
									dateoverlay = true;
								}
								else
								{
									dateoverlay = false;
								}
							}
						});
					}
				}  
			}
    	}); 
		/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	}else{
		$.ajax(
		{
			dataType: "json",
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlconfgeneral&maxvalues=100&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{
				CheckTokenValidity(data);
				$.each(data, function(i, item)
				{
					if (item.id == 55)
					{
						if (item.value == "true")
						{
							dateoverlay = true;
						}
						else
						{
							dateoverlay = false;
						}
					}
				});
			}
		});
	}		
	
	//GET VICON RESOLUTION
	getViconResolution();

	if (DEFINE_INTERFACE == "VIVOTEK" || DEFINE_INTERFACE == "VIVOTEK_CV25")
	{
		// GET TIMESTAMP VIVOTEK
		$.ajax(
		{
			url: pathcgi + "../cgi-bin/admin/getparam.cgi?videoin_imprinttimestamp",
			async: false,
			success: function (data)
			{
				if (data.split("=").length > 1)
				timestamp_vivotek = data.split("=")[1].split("'")[1];
			}
		});
	}else if(DEFINE_INTERFACE == "HANWHA"){

	}

	function refrescaImagen()
	{
		resfreshliveview();
		timer = setTimeout(refrescaImagen, timerefreshImagen);
	}

	function refrescaInfo()
	{
		if(DEFINE_INTERFACE == "HANWHA"){
			timerefreshInfo = 2000;
			timerfuncHanwha();
			timer2 = setTimeout(refrescaInfo, timerefreshInfo);
		}else{
			timerefreshInfo = 1000;
			timerfunc();
			timer2 = setTimeout(refrescaInfo, timerefreshInfo);
		}
	}

	function refrescaStatus()
	{
		if(DEFINE_INTERFACE == "HANWHA")
			timerrefreshStatus = 5000;
		else
			timerrefreshStatus = 1000;
		
		timerstatus();
		timer3 = setTimeout(refrescaStatus, timerrefreshStatus);
		
	}
	
	//old version
	function resfreshliveview()
	{
		var d1 = new Date();
		var canvas = document.getElementById('canvas');
		var ctx = canvas.getContext('2d');
		var tmpImg = new Image();
		tmpImg.src = pathcgi + pathlive + "&i=" + getStringNormalDate(d1) + localStorage.getItem("TOKEN");
		tmpImg.onload = function()
		{
			try
			{
				ctx.drawImage(tmpImg, 0, 0, wdefined, hdefined);
				if (DEFINE_INTERFACE == "VICON")
				{
					getViconResolution();
					if (viconresolution)
					{
						ctx.fillStyle = 'white';
						ctx.fillRect(0, 0, wdefined, hdefined);
						
						ctx.font = "32px Arial";
						ctx.fillStyle = "#2B56A3";
						ctx.fillText(DevExpress.localization.formatMessage("Resolution is too high,"), 25, 175, wdefined);
						ctx.fillText(DevExpress.localization.formatMessage("please select a lower resolution"), 25, 225, wdefined);
					}
				}
				if (showroi && !viconresolution)
				{
					if (roiwidth != 0)
					{
						ctx.beginPath();
						var ppcX = parseFloat("0." + roileft);
						var ppcY = parseFloat("0." + roitop);
						var ppcwidth = parseFloat("0." + roiwidth);
						var ppcheight = parseFloat("0." + roiheight);
						ctx.rect(ppcX * wdefined, ppcY * hdefined, ppcwidth * wdefined, ppcheight * hdefined);
						ctx.strokeStyle = 'red';
						ctx.lineWidth = 5;
						ctx.stroke();
					}
					else if (roimessagedisplayed == false)
					{
						DevExpress.ui.notify(DevExpress.localization.formatMessage("No ROI to display"), "info", 1000);
						roimessagedisplayed = true;
					}
				}
				if (showlanes && !viconresolution)
				{
					if (haveLanes)
					{
						ctx.beginPath();
						ctx.strokeStyle = 'blue';
						ctx.lineWidth = 2;
						ctx.moveTo(p0, 0);
						ctx.lineTo(p1, hdefined);
						ctx.stroke();
					}
					else if (lanesmessagedisplayed == false)
					{
						DevExpress.ui.notify(DevExpress.localization.formatMessage("No lanes to display"), "info", 1000);
						lanesmessagedisplayed = true;
					}
				}
				if (showpattern && !viconresolution)
				{
					var linedraw = Math.round((25 * hdefined) / resy);
					ctx.beginPath();
					ctx.strokeStyle = 'white';
					ctx.lineWidth = 2;
					for (i = 0; i < hdefined; i += linedraw)
					{
						ctx.moveTo(0, i);
						ctx.lineTo(wdefined, i);
						ctx.stroke();
					}
				}
				if (showcrossline && !viconresolution)
				{
					if (haveCrossline)
					{
						for (var i=0; i<numCrossline; i++)
						{
							ctx.beginPath();
							ctx.strokeStyle = 'green';
							ctx.lineWidth = 2;
							ctx.moveTo(x0[i], y0[i]);
							ctx.lineTo(x1[i], y1[i]);
							ctx.stroke();
							
							ctx.beginPath();
							ctx.rect(clarea1[i], clarea2[i], clarea3[i], clarea4[i]);
							ctx.strokeStyle = 'green';
							ctx.lineWidth = 5;
							ctx.stroke();
						}
					}
					else if (crosslinemessagedisplayed == false)
					{
						DevExpress.ui.notify(DevExpress.localization.formatMessage("No Cross Line to display"), "info", 1000);
						crosslinemessagedisplayed = true;
					}
				}
				if ((dateoverlay) && ((!DEFINE_INTERFACE.includes("VIVOTEK")) || ((DEFINE_INTERFACE == "VIVOTEK"  || DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA") && (timestamp_vivotek == "0"))))
				{
					var date = getStringNormalDateLive(d1);
					ctx.font = "14px Arial";
					ctx.strokeStyle = 'black';
					ctx.strokeText(date, 10, 20, wdefined);
					ctx.fillStyle = 'white';
					ctx.fillText(date, 10, 20, wdefined);
				}
			}
			catch (err)
			{}
		};
	}
	
	/*
	function resfreshliveview()
	{
	
		var d1 = new Date();
		

		var canvas = document.getElementById('canvas');
		var ctx = canvas.getContext('2d');
	
		ctx.clearRect(0, 0, canvas.width, canvas.height); //clear canvas
		ctx.beginPath();
							
		ctx.stroke();
				if(showpattern)
				{
					var linedraw=  Math.round((25*hdefined) / resy);
					ctx.beginPath();
					ctx.strokeStyle = 'white';
					ctx.lineWidth = 2;
					for (i = 0; i < hdefined; i+=linedraw) {
						ctx.moveTo(0, i);
						ctx.lineTo(wdefined, i);
						ctx.stroke();
					}		
					
				}
				
				if(showroi)
				{
					if (roiwidth != 0) {
						ctx.beginPath();
							var ppcX= parseFloat("0."+roileft);
				var ppcY= parseFloat("0."+roitop );
				var ppcwidth= parseFloat("0."+roiwidth);
				var ppcheight= parseFloat("0."+roiheight);
				ctx.rect(ppcX * wdefined , ppcY * hdefined , ppcwidth * wdefined ,ppcheight * hdefined );
						ctx.strokeStyle = 'red';
						ctx.lineWidth = 5;
						ctx.stroke();
					}
					else{
						DevExpress.ui.notify( DevExpress.localization.formatMessage("No ROI to display"), "info", 600);
					}
				}
				if(showlanes)
				{
					if(haveLanes)
					{
							ctx.beginPath();
							ctx.strokeStyle = 'blue';
							ctx.lineWidth = 2;
							ctx.moveTo(p0, 0);
							ctx.lineTo(p1, hdefined);
							ctx.stroke();
												
					}
					else{
						DevExpress.ui.notify(DevExpress.localization.formatMessage("No lines to display"), "info", 600);
					}
					
				}		
		

		
		
	}
	 */
	
	function getViconResolution()
	{

		if(DEFINE_INTERFACE == "HANWHA"){
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			var msg = "";
			msg += "<GetSDK_APP_DATA>";
			msg += "<AppName>NeuralEdge</AppName>";
			msg += "<Data>computerid=" + computerid + "|oper=select|table=nlcounter|camp0=id|comp0=minor|value0=100|maxvalues=100|adinfo=notvalue</Data>";	
			msg += "</GetSDK_APP_DATA>";

			
			addToQueue(msg, function(response) {
				var data = response; 
	        	if(data!=undefined && data!=""){
  					console.log("Datos consulta: " + msg);
					console.log("Respuesta : " + JSON.stringify(data));
					console.log("Respuesta status: " + data);
					try {  
					  resData = JSON.parse(data); 
					} catch (e) {  
					  console.log('invalid json'); 
					  return; 
					}

					CheckTokenValidity(data);
					if(Array.isArray(data)){
						if(data.length>0){
							$.each(data, function(i, item)
							{
								if (item.id == 55)
								{
									if (item.value == "true")
									{
										dateoverlay = true;
									}
									else
									{
										dateoverlay = false;
									}
								}
							});
						}
					}   
				}		  			
	    	}); 
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		}else{
			$.ajax(
			{
				dataType: "json",
				url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlcounter&maxvalues=100&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
				async: false,
				success: function(data)
				{
					CheckTokenValidity(data);
					$.each(data, function(i, item)
					{
						if (item.ident == "vicon_resolution")
						{
							if (item.value == 1)
							{
								viconresolution = true;
							}
							else
							{
								viconresolution = false;
							}
						}
					});
				}
			});
		}
	}
	
	function settitleinfotitle(i, data, jj)
	{
		var j = 0;
		var lane = "";
		var iconimages = "";
		$("#title" + i).empty();
		$("#list" + i).empty();
		$("#make" + i).empty();
		$("#class" + i).empty();
		if (data[jj].laneid != 0)
		{
			if (data[jj].laneid % 2 == 0)
			{
				lane = "[" + DevExpress.localization.formatMessage("LANE 1") + "]";
			}
			else
			{
				lane = "[" + DevExpress.localization.formatMessage("LANE 2") + "]";
			}
		}
		if (data[jj].imagepath != "")
		{
			iconimages = "<img id='icimgt" + data[jj].id + "' src=images/images.png ><div id='tooltipt" + data[jj].id + "' style='display: none !important;'></div>"
		}

		var strDate = data[jj].timestamp.replace("T", " ");
		var itemDate = new Date(data[jj].timestamp.replace("T", " "));
		if(isNaN(itemDate))
		{
		    itemDate= new Date(data[jj].timestamp+'Z');
		}
		try{
			var formatedDate = liveDateFormat;
			formatedDate = formatedDate.replace("yyyy", itemDate.getFullYear());

			var month = itemDate.getMonth() +1;
			if(month < 10)
				month = "0"+month;
			formatedDate = formatedDate.replace("MM", month);

			var day = itemDate.getDate();
			if(day < 10)
				day = "0"+day;
			formatedDate = formatedDate.replace("dd", day);

			var milis = itemDate.getMilliseconds();
			if(milis < 10)
				milis = "0"+milis;
			formatedDate = formatedDate.replace("SSS", milis);

			var secs = itemDate.getSeconds();
			if(secs < 10)
				secs = "0"+secs;
			formatedDate = formatedDate.replace("ss", secs);

			var mins = itemDate.getMinutes();
			if(mins < 10)
				mins = "0"+mins;
			formatedDate = formatedDate.replace("mm", mins);

			var hours = itemDate.getHours();
			if(formatedDate.includes("hh")){
				hours = (itemDate.getHours() % 12) || 12;
				if(hours < 10)
					hours = "0"+hours;
				formatedDate = formatedDate.replace("hh",hours);
			}else if(formatedDate.includes("HH")){
				hours = itemDate.getHours();
				if(hours < 10)
					hours = "0"+hours;
				formatedDate = formatedDate.replace("HH", hours);
			}

			strDate = formatedDate;
		}catch(e){

		}

		$("#title" + i).append("<b>" + data[jj].numberplate + "</b> (" + dict[data[jj].country] + ") " + iconimages + "<br> " + lane + " " + data[jj].globalconfidence + "% " + data[jj].averagecharheight + "px <br>" + strDate + "<br>");
		
		if(DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA"){
			if(data[jj].make_str != null && data[jj].make_str != undefined && data[jj].veclass_str != undefined && data[jj].veclass_str != undefined && data[jj].color_str != undefined && data[jj].color_str != undefined){
				//data[jj].make_str = "testMaker";
				var classColor = data[jj].veclass_str.replace(/NLVEHICLE_CLASS_/g,'').toLowerCase() +"_"+ data[jj].color_str.toLowerCase();
				//var classColor = "VEHICLE_CLASS_MOTO".replace(/VEHICLE_CLASS_/g,'').toLowerCase() +"_"+ "PURPLE".toLowerCase();
				var tooltipText = classColor.split("_")[0]+" - "+classColor.split("_")[1];
					if(tooltipText == " - ")
						tooltipText="";
				$("#class"+ i).append("<img title='"+tooltipText+"' src="+getClassIcon(classColor)+" >"+"<label style='font-size: 11px;'>" + data[jj].make_str + "</label>");
			}
		}else{
			$("#class"+ i).remove();
		}

		var lists = "";
		if (data[jj].listid != "[-1]")
		{
			if (data[jj].listid.includes(";"))
			{
				var listas = data[jj].listid.split(";");
				$.each(listas, function(i, item)
				{
					lists += dictlist[item] + ";";
				});
				lists = lists.slice(0, -1);
			}
			else
			{
				lists = dictlist[data[jj].listid];
			}
			$("#list" + i).append(lists);
		}
		if (data[jj].imagepath != "")
		{
			//console.log("Creo tooltip" + jj);
			CreateToolTipTop(data[jj].id, data[jj].evidences, data[jj].imagepath, data[jj].resultleft, data[jj].resulttop, data[jj].resultright, data[jj].resultbottom, data[jj].width, data[jj].height, jj);
		}
	}

	function timerstatus()
	{
		if (showstatus)
		{
			loadStatus();
			if (DEFINE_INTERFACE == "VIVOTEK" || DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "AXIS" || DEFINE_INTERFACE == "VICON" || DEFINE_INTERFACE == "HANWHA")
			{
				$('#gridstatus').dxDataGrid('instance').option("dataSource", status);
			}
		}
	}

	function timerfunc()
	{
		if (showreallive)
		{
			if (!liveVelocidad)
			{
				var d = new Date();
				var urlpetition = "";
				urlpetition = pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=jsonlastresults&d=" + getStringNormalDate(d) + localStorage.getItem("TOKEN"),
					$.ajax(
					{
						dataType: "json",
						url: urlpetition,
						async: false,
						success: function(data)
						{
							CheckTokenValidity(data);
							if (data.length > 0)
							{
								var dataGrid2 = $('#gridContainer2').dxDataGrid('instance');
								
								var diffItems = false; 
								var dataItemsIDs = lastSquareResults;
								var resultItemsIDs =[];

								for(var j = 0; j < data.length; j++){
									resultItemsIDs.push(Number(data[j].id));
								}

								dataItemsIDs.sort();
								resultItemsIDs.sort();

								if(JSON.stringify(dataItemsIDs) != JSON.stringify(resultItemsIDs))
									diffItems=true;

								lastSquareResults = resultItemsIDs;
								if(!diffItems)
									return;

								var last_index = ((index_peticion - 1) % 5);
								data.sort(function(a, b)
								{
									return b.id - a.id
								})
								$.each(data, function(indice, item)
								{
									if (indice < 5)
									{
										lastid = data[indice].id;
										var i = (index_peticion % 5);
										var j = 0;
										$('#imageretail' + i).hide();
										$('#image' + i).hide();
										if (data[indice].imagepath != "")
										{
											$('#image' + i).show();
											var canvas = document.getElementById('canvas' + i);
											var ctx = canvas.getContext('2d');
											var tmpImg = new Image();
											tmpImg.src = pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getimage&path=" + data[indice].imagepath + localStorage.getItem("TOKEN");
											tmpImg.onerror = function()
											{
												settitleinfotitle(i, data, indice);
												$('.boxOptions1').css('height', '282px');
											};
											tmpImg.onload = function()
											{
												settitleinfotitle(i, data, indice);
												$('.boxOptions1').css('height', '282px');
												// Store the current transformation matrix
												ctx.save();
												// Use the identity matrix while clearing the canvas
												ctx.setTransform(1, 0, 0, 1, 0, 0);
												ctx.clearRect(0, 0, 228, 192);
												// Restore the transform
												ctx.restore();
												ctx.beginPath();
												ctx.clearRect(0, 0, 228, 192);
												ctx.drawImage(tmpImg, 0, 0, 228, 192);
												ctx.rect(data[indice].resultleft * (widthdraw / data[indice].width), data[indice].resulttop * (heightdraw / data[indice].height), (data[indice].resultright - data[indice].resultleft) * (widthdraw / data[indice].width), (data[indice].resultbottom - data[indice].resulttop) * (heightdraw / data[indice].height));
												ctx.strokeStyle = 'green';
												ctx.lineWidth = 1;
												ctx.stroke();
											};
										}
										else if (data[indice].imageretailpath != "")
										{
											$('.boxOptions1').css('height', '150px');
											$('#imageretail' + i).show();
											$('#imgrtl' + i).attr('src', pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getimage&path=" + data[indice].imageretailpath + localStorage.getItem("TOKEN"));
											settitleinfotitle(i, data, indice);
										}
										else
										{
											settitleinfotitle(i, data, indice);
											$('.boxOptions1').css('height', '95px');
										}
										index_peticion++;
									}
								});
								var index_actual = (index_peticion - 1) % 5;
								//$("#mat" + last_index).removeClass('demo-light');
								//$("#mat" + last_index).addClass('demo-dark');
								//$("#mat" + index_actual).removeClass('demo-dark');
								$("#mat" + last_index).addClass('demo-light');
								$("#mat" + index_actual).addClass('demo-light');
							}
						}
					});
			}
			else
			{
				$.ajax(
				{
					async: false,
					dataType: "json",
					url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=jsonlastresults&d=" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
					success: function(data)
					{
						CheckTokenValidity(data);
						results = data;
						//put a try/catch because the first time this timer fires the datagrid is not created, but the second and subsequent times there is no error and everything works as normal
						try
						{
							var dataItems = $('#gridContainer').dxDataGrid('instance').getDataSource().items();
							
							var diffItems = false; 
							var dataItemsIDs =[];
							var resultItemsIDs =[];

							for(var i = 0; i < dataItems.length; i++){
								dataItemsIDs.push(Number(dataItems[i].id));
							}
							for(var j = 0; j < results.length; j++){
								resultItemsIDs.push(Number(results[j].id));
							}

							dataItemsIDs.sort();
							resultItemsIDs.sort();

							if(JSON.stringify(dataItemsIDs) != JSON.stringify(resultItemsIDs))
								diffItems=true;

							if(diffItems)
							$('#gridContainer').dxDataGrid('instance').option("dataSource", results);
						
							diffItems = false;
						}
						catch (err)
						{}
					}
				});
			}
		}
	};
	function timerfuncHanwha()
	{
		if (showHamwhaRes)
		{
			if (!liveVelocidad)
			{
				var d = new Date();
				/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				var msg = "";
				msg += "<GetSDK_APP_DATA>";
				msg += "<AppName>NeuralEdge</AppName>";
				msg += "<Data>computerid=" + computerid + "|oper=jsonlastresults|adinfo=notvalue</Data>";	
				msg += "</GetSDK_APP_DATA>";

				addToQueue(msg, function(response) {
					var resData = response; 
		        	if(resData!=undefined && resData!=""){
	  					console.log("Datos consulta: " + msg);
						console.log("Respuesta : " + JSON.stringify(resData));
						console.log("Respuesta status: " + resData);
						try {  
						  resData = JSON.parse(resData); 
						} catch (e) {  
						  console.log('invalid json'); 
						  return; 
						}

						CheckTokenValidity(resData);
							if (resData.length > 0)
							{
								var dataGrid2 = $('#gridContainer2').dxDataGrid('instance');
								
								var diffItems = false; 
								var dataItemsIDs = lastSquareResults;
								var resultItemsIDs =[];

								for(var j = 0; j < resData.length; j++){
									resultItemsIDs.push(Number(resData[j].id));
								}

								dataItemsIDs.sort();
								resultItemsIDs.sort();

								if(JSON.stringify(dataItemsIDs) != JSON.stringify(resultItemsIDs))
									diffItems=true;

								lastSquareResults = resultItemsIDs;
								if(!diffItems)
									return;

								var last_index = ((index_peticion - 1) % 5);
								resData.sort(function(a, b)
								{
									return b.id - a.id
								})
								$.each(resData, function(indice, item)
								{
									if (indice < 5)
									{
										lastid = resData[indice].id;
										var i = (index_peticion % 5);
										var j = 0;

										var serverName	= window.location.hostname;
										var serverType = "http://";
										var extention = "/livemjpeg";
										var liveStreamURI = serverType + serverName + ":8080" + extention;
										// $("#streaming_uri").attr("src", liveStreamURI);

										$('#imageretail' + i).hide();
										$('#image' + i).hide();
										if (resData[indice].imagepath != "")
										{
											$('#image' + i).show();
											var canvas = document.getElementById('canvas' + i);
											var ctx = canvas.getContext('2d');
											var tmpImg = new Image();
											tmpImg.src = "http://213.195.119.4:8006/cgi-bin/stw.cgi?computerid=" + computerid + "&oper=getimage&path=" + resData[indice].imagepath;
											//tmpImg.src = liveStreamURI;
											tmpImg.onerror = function()
											{	
												console.log("Error: tmpImg.onerror");
												settitleinfotitle(i, resData, indice);
												$('.boxOptions1').css('height', '282px');
											};
											tmpImg.onload = function()
											{
												console.log("Entro: tmpImg.onload");
												settitleinfotitle(i, resData, indice);
												$('.boxOptions1').css('height', '282px');
												// Store the current transformation matrix
												ctx.save();
												// Use the identity matrix while clearing the canvas
												ctx.setTransform(1, 0, 0, 1, 0, 0);
												ctx.clearRect(0, 0, 228, 192);
												// Restore the transform
												ctx.restore();
												ctx.beginPath();
												ctx.clearRect(0, 0, 228, 192);
												ctx.drawImage(tmpImg, 0, 0, 228, 192);
												ctx.rect(resData[indice].resultleft * (widthdraw / resData[indice].width), resData[indice].resulttop * (heightdraw / resData[indice].height), (resData[indice].resultright - resData[indice].resultleft) * (widthdraw / resData[indice].width), (resData[indice].resultbottom - resData[indice].resulttop) * (heightdraw / resData[indice].height));
												ctx.strokeStyle = 'green';
												ctx.lineWidth = 1;
												ctx.stroke();
											};
										}
										else if (resData[indice].imageretailpath != "")
										{
											$('.boxOptions1').css('height', '150px');
											$('#imageretail' + i).show();
											// $('#imgrtl' + i).attr('src', liveStreamURI);
											$('#imgrtl' + i).attr('src', "http://213.195.119.4:8006/cgi-bin/stw.cgi?computerid=cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getimage&path=" + resData[indice].imageretailpath);
											
											settitleinfotitle(i, resData, indice);
										}
										else
										{
											settitleinfotitle(i, resData, indice);
											$('.boxOptions1').css('height', '95px');
										}
										index_peticion++;
									}
								});
								var index_actual = (index_peticion - 1) % 5;
								//$("#mat" + last_index).removeClass('demo-light');
								//$("#mat" + last_index).addClass('demo-dark');
								//$("#mat" + index_actual).removeClass('demo-dark');
								$("#mat" + last_index).addClass('demo-light');
								$("#mat" + index_actual).addClass('demo-light');
							}
						
					}
		    	}); 
				/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			}
			else
			{
				/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				var msg = "";
				msg += "<GetSDK_APP_DATA>";
				msg += "<AppName>NeuralEdge</AppName>";
				msg += "<Data>computerid=" + computerid + "|oper=jsonlastresults|adinfo=notvalue</Data>";	
				msg += "</GetSDK_APP_DATA>";

				
				addToQueue(msg, function(response) {
					var resData = response; 
		        	if(resData!=undefined && resData!=""){
	  					console.log("Datos consulta: " + msg);
						console.log("Respuesta : " + JSON.stringify(resData));
						console.log("Respuesta status: " + resData);
						try {  
						  resData = JSON.parse(resData); 
						} catch (e) {  
						  console.log('invalid json'); 
						  return; 
						}

						CheckTokenValidity(resData);
						results = resData;
						//put a try/catch because the first time this timer fires the datagrid is not created, but the second and subsequent times there is no error and everything works as normal
						try
						{
							var dataItems = $('#gridContainer').dxDataGrid('instance').getDataSource().items();
							
							var diffItems = false; 
							var dataItemsIDs =[];
							var resultItemsIDs =[];

							for(var i = 0; i < dataItems.length; i++){
								dataItemsIDs.push(Number(dataItems[i].id));
							}
							for(var j = 0; j < results.length; j++){
								resultItemsIDs.push(Number(results[j].id));
							}

							dataItemsIDs.sort();
							resultItemsIDs.sort();

							if(JSON.stringify(dataItemsIDs) != JSON.stringify(resultItemsIDs))
								diffItems=true;

							if(diffItems)
							$('#gridContainer').dxDataGrid('instance').option("dataSource", results);
						
							diffItems = false;
						}catch (err){

						}
					}
		    	}); 
				/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			}
		}
	};
	

	if(DEFINE_INTERFACE == "HANWHA"){
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			var msg = "";
			msg += "<GetSDK_APP_DATA>";
			msg += "<AppName>NeuralEdge</AppName>";
			msg += "<Data>computerid=" + computerid + "|oper=jsonlastresults|adinfo=notvalue</Data>";	
			msg += "</GetSDK_APP_DATA>";

			
			addToQueue(msg, function(response) {
				var resData = response; 
	        	if(resData!=undefined && resData!=""){
  					console.log("Datos consulta: " + msg);
					console.log("Respuesta : " + JSON.stringify(resData));
					console.log("Respuesta status: " + resData);
					try {  
					  resData = JSON.parse(resData); 
					} catch (e) {  
					  console.log('invalid json'); 
					  return; 
					}

					CheckTokenValidity(resData);
					if(resData!=undefined && resData!=""){
						results = resData;
					}
				}
	    	}); 
			/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	}else{
		$.ajax(
		{
			dataType: "json",
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=jsonlastresults&d=" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{
				CheckTokenValidity(data);
				results = data;
			}
		});
	}
	$(".boxOptions1").dxBox(
	{
		direction: "row",
		width: "100%",
		height: 270
	});
	loadStatus();
	
	$("#gridstatus").dxDataGrid(
	{
		dataSource: status,
		showColumnHeaders: true,
		showBorders: true,
		showRowLines: true,
		keyExpr: "ident",
		hoverStateEnabled: true,
		columns: [
		{
			dataField: "text",
			caption: DevExpress.localization.formatMessage("Atribute"),
			width: 170,
			cellTemplate: function(element, info)
			{
				if (info.row.data.ident == "service")
				{
					var ee = info.text.split(";")
					if (ee.length > 1)
					{
						element.append(DevExpress.localization.formatMessage(ee[0]) + ee[1]);
					}
					else
					{
						element.append(DevExpress.localization.formatMessage(info.text));
					}
				}
				else
				{
					element.append(DevExpress.localization.formatMessage(info.text))
				}
			}
		},
		{
			width: 100,
			dataField: "value",
			caption: DevExpress.localization.formatMessage("Value"),
			cellTemplate: function(element, info)
			{
				if (info.row.data.ident != "service")
				{
					element.append(info.text)
				}
				else
				{
					if (info.text == "-1")
					{
						element.append("STOPPED")
					}
					if (info.text == "0")
					{
						element.append("NO LICENSE")
					}
					if (info.text == "1")
					{
						element.append("TRIGGER")
					}
					if (info.text == "2")
					{
						element.append("FREEFLOW")
					}
					if (info.text == "3")
					{
						element.append("MOTION")
					}
					if (info.text == "4")
					{
						element.append("LOADING")
					}
				}
			}
		},
		{
			dataField: "lastchange",
			dataType: "date",
			caption: DevExpress.localization.formatMessage("Last Change"),
			width: 180,
			format: liveDateFormat
		}],
		onRowPrepared: function(row)
		{
			if (row.rowType == "data")
			{
				row.rowElement[0].style.whiteSpace = "break-spaces";
				//console.log("TEST ASTERISCO: Traduccion '"+ DevExpress.localization.formatMessage(row.data.text) + "' vs original '" + row.data.text+"'");
				//row.rowElement[0].title = DevExpress.localization.formatMessage(row.data.text) != row.data.text ? DevExpress.localization.formatMessage(row.data.text) : row.data.text+"*";
				row.rowElement[0].title = DevExpress.localization.formatMessage(row.data.text);
				
				if ((row.data.ident == "SD" || row.data.ident == "CAMERA") && row.data.value <= 15 && row.data.value > 5)
				{
					row.rowElement.addClass('Yellow');
				}
				if ((row.data.ident == "SD" || row.data.ident == "CAMERA") && row.data.value <= 5)
				{
					row.rowElement.addClass('Red');
				}
				if (row.data.ident == "service" && row.data.value < 1)
				{
					row.rowElement.addClass('Red');
				}
				if (row.data.ident == "service" && row.data.value == 4)
				{
					row.rowElement.addClass('Yellow');
				}
			}
		}
	});
	if (visorType == "realtime"){
		
	}else if (visorType == "getimage"){
		refrescaImagen();
	}
	refrescaInfo();
	refrescaStatus();
	
	//CARGAR PARA VELOCIDAD O STOPANDGO
	if (liveVelocidad)
	{
		$("#bxopt1").hide();
		$("#gridContainer").dxDataGrid(
		{
			dataSource: results,
			showBorders: true,
			showRowLines: true,
			keyExpr: "id",
			height: 270,
			hoverStateEnabled: true,
			columns: [
				{
					dataField: "id",
					caption: "ID",
					width: 80,
					sortIndex: 0,
					sortOrder: "desc"
				},
				{
					dataField: "timestamp",
					dataType: "date",
					caption: DevExpress.localization.formatMessage("Time"),
					width: 180,
					format: liveDateFormat
				},
				{
					width: 100,
					dataField: "numberplate",
					caption: DevExpress.localization.formatMessage("Plate")
				}, ,
				{
					width: 80,
					dataField: "laneid",
					caption: DevExpress.localization.formatMessage("Lane"),
					visible:LaneVisible,
					cellTemplate: function(element, info)
					{
						if (info.text == 0)
						{
							element.append("");
						}
						else
						{
							if (info.text % 2 == 0)
							{
								element.append(DevExpress.localization.formatMessage("LANE 1"));
							}
							else
							{
								element.append(DevExpress.localization.formatMessage("LANE 2"));
							}
						}
					}
				},
				//Faltan DirectionVisible - SpeedVisible - 
				{
					width: 100,
					dataField: "direction",
					visible: DirectionVisible, 
					caption: DevExpress.localization.formatMessage("Direction"),
					cellTemplate: function(element, info)
					{
						if (info.text == 0)
						{
							element.append(DevExpress.localization.formatMessage("No Direction"));
						}
						else if (info.text == 1)
						{
							element.append(DevExpress.localization.formatMessage("Coming"));
						}
						else if (info.text == -1)
						{
							element.append(DevExpress.localization.formatMessage("Going"));
						}
					}
				},
				{
					width: 60,
					dataField: "speed",
					visible: SpeedVisible, 
					caption: DevExpress.localization.formatMessage("Speed")
				},
				{
					width: 60,
					dataField: "globalconfidence",
					visible: ConfVisible, 
					caption: DevExpress.localization.formatMessage("Conf.")
				},
				{
					width: 80,
					dataField: "averagecharheight",
					visible: HeightVisible,
					caption: DevExpress.localization.formatMessage("Heigth")
				},
				{
					width: 90,
					dataField: "processtime",
					caption: DevExpress.localization.formatMessage("Time"),
					visible: debugoptions
				},
				{
					width: 150,
					dataField: "country",
					visible: CountryVisible,
					caption: DevExpress.localization.formatMessage("CountryState"),
					cellTemplate: function(element, info)
					{
						element.append(dict[info.text]);
					}
				},
				{
					dataField: "listid",
					visible: ListVisible,
					caption: DevExpress.localization.formatMessage("List"),
					cellTemplate: function(element, info)
					{
						if (info.text != "[-1]")
						{
							var listastring = "";
							if (info.text.includes(";"))
							{
								var listas = info.text.split(";");
								$.each(listas, function(i, item)
								{
									listastring += dictlist[item] + ";";
								});
								listastring = listastring.slice(0, -1);
							}
							else
							{
								listastring = dictlist[info.text];
							}
							element.append(listastring);
						}
						else
						{
							element.append("");
						}
					}
				},
				{
					width: 90,
					dataField: "veclass_str",
					caption: DevExpress.localization.formatMessage("Class"),
					calculateCellValue: function(rowData) {
		                return rowData.veclass_str.replace(/NLVEHICLE_CLASS_/g,'').toLowerCase() +"_"+ rowData.color_str.toLowerCase();
		                //return "2" +"#"+ "RED";
		            },
					cellTemplate: function(element, info)
					{	
						element.css({textAlign: "center"});
						//element.append(info.text.split("#")[0]);
						element.append("<img src='" + getClassIcon(info.text)  + "' height = '20' width='20'>");
					},
					visible: ClassVisible
				},
				{
					width: 90,
					dataField: "make_str",
					caption: DevExpress.localization.formatMessage("Make"),
					visible: MakeVisible
				},
				{
					dataField: "imageretailpath",
					caption: DevExpress.localization.formatMessage("Image"),
					width: 150,
					cellTemplate: function(element, info)
					{
						if (info.text != "")
						{
							if(DEFINE_INTERFACE == "HANWHA"){
								element.append(DevExpress.localization.formatMessage("No image"));
							}else{
								element.append("<img id='icimg" + info.key + "' src='" + pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=getimage&path=" + info.text + localStorage.getItem("TOKEN") + "' height = '20' width='125'><div id='tooltip" + info.key + "'></div>")
								if (info.row.data.imagepath != "")
								{
									CreateToolTip(info.key, info.row.data.evidences, info.row.data.imagepath, info.row.data.resultleft, info.row.data.resulttop, info.row.data.resultright, info.row.data.resultbottom, info.row.data.width, info.row.data.height);
								}
							}

						}
						else
						{
							element.append(DevExpress.localization.formatMessage("No image"));
						}
					}
				}
			],
			onRowPrepared: function(row)
			{
				if (row.rowType == "data")
				{
					if(ListVisible){
						if(row.values.indexOf("[-1]") == -1)
								row.rowElement.addClass('Red');
					}
					//if (debugoptions)
					//{
					//	if (row.values[8] != "[-1]")
					//	{
					//		row.rowElement.addClass('Red');
					//	}
					//}
					//else
					//{
					//	if (row.values[7] != "[-1]")
					//	{
					//		row.rowElement.addClass('Red');
					//	}
					//}
				}
			}
		});

	}

	function getClassIcon(id){
		if (id == "_"){
			id = "empty";
		}
		else if (id == "unknown_"){
			id = "empty";
		}
		else {
			if(id.split("_")[0].length == 0){
				id = "unknown"+id;
			}
			else if(id.split("_")[1].length == 0){
				id = id+"white";
			}
		}
		//console.log("images/"+id+".png");
	    return "images/"+id+".png";
	}
	function detectIE()
	{
		var ua = window.navigator.userAgent;
		var msie = ua.indexOf('MSIE ');
		if (msie > 0)
		{
			// IE 10 or older => return version number
			return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
		}
		var trident = ua.indexOf('Trident/');
		if (trident > 0)
		{
			// IE 11 => return version number
			var rv = ua.indexOf('rv:');
			return parseInt(ua.substring(rv + 3, ua.indexOf('.', rv)), 10);
		}
		var edge = ua.indexOf('Edge/');
		if (edge > 0)
		{
			// Edge (IE 12+) => return version number
			return parseInt(ua.substring(edge + 5, ua.indexOf('.', edge)), 10);
		}
		// other browser
		return false;
	}
});
